diff -u -r -N squid-3.0.STABLE16-RC1/ChangeLog squid-3.0.STABLE16/ChangeLog
--- squid-3.0.STABLE16-RC1/ChangeLog	2009-05-16 00:47:46.000000000 +1200
+++ squid-3.0.STABLE16/ChangeLog	2009-06-15 19:31:05.000000000 +1200
@@ -1,6 +1,20 @@
+Changes to squid-3.0.STABLE16 (15 Jun 2009):
+
+	- Bug 2672: cacheMemMaxSize 32-bit overflow during snmpwalk
+	- Bug 2481: Don't set expires: now in generated error responses
+	- Bug 2387: The calculation of the number of hash buckets correctly
+	- Fix infinite loop in MSNT auth helper
+	- Fix FD_SETSIZE on FreeBSD
+	- Fix stripping NT domain in squid_ldap_group
+	- Fix RADIUS auth helper build
+	- Add Translate: and Unless-Modified-Since: headers to known list
+	- Make fakeauth handle NTLMv2 better
+	- Better Kerberos support detection
+	- Several Widows port fixes
+
 Changes to squid-3.0.STABLE16-RC1 (16 May 2009):
 
-	- Bug 1148 Ported from 3.1: Chunked Transfer Encoding
+	- Bug 1148: Ported from 3.1: Chunked Transfer Encoding
 	- Bug 2648: NTLM helpers not shutting down when deferred
 
 Changes to squid-3.0.STABLE15 (06 May 2009):
diff -u -r -N squid-3.0.STABLE16-RC1/configure squid-3.0.STABLE16/configure
--- squid-3.0.STABLE16-RC1/configure	2009-05-16 00:47:59.000000000 +1200
+++ squid-3.0.STABLE16/configure	2009-06-15 19:31:33.000000000 +1200
@@ -1,7 +1,7 @@
 #! /bin/sh
 # From configure.in Revision: 1.488.2.3 .
 # Guess values for system-dependent variables and create Makefiles.
-# Generated by GNU Autoconf 2.62 for Squid Web Proxy 3.0.STABLE16-RC1.
+# Generated by GNU Autoconf 2.62 for Squid Web Proxy 3.0.STABLE16.
 #
 # Report bugs to <http://www.squid-cache.org/bugs/>.
 #
@@ -751,8 +751,8 @@
 # Identity of this package.
 PACKAGE_NAME='Squid Web Proxy'
 PACKAGE_TARNAME='squid'
-PACKAGE_VERSION='3.0.STABLE16-RC1'
-PACKAGE_STRING='Squid Web Proxy 3.0.STABLE16-RC1'
+PACKAGE_VERSION='3.0.STABLE16'
+PACKAGE_STRING='Squid Web Proxy 3.0.STABLE16'
 PACKAGE_BUGREPORT='http://www.squid-cache.org/bugs/'
 
 ac_unique_file="src/main.cc"
@@ -966,6 +966,11 @@
 NTLM_AUTH_HELPERS
 NEGOTIATE_AUTH_HELPERS
 DIGEST_AUTH_HELPERS
+ac_krb5_config
+KRB5INCS
+KRB5LIBS
+HAVE_SPNEGO_TRUE
+HAVE_SPNEGO_FALSE
 EXTERNAL_ACL_HELPERS
 LIBSASL
 ENABLE_UNLINKD_TRUE
@@ -1663,7 +1668,7 @@
   # Omit some internal or obsolete options to make the list less imposing.
   # This message is too long to be a string in the A/UX 3.1 sh.
   cat <<_ACEOF
-\`configure' configures Squid Web Proxy 3.0.STABLE16-RC1 to adapt to many kinds of systems.
+\`configure' configures Squid Web Proxy 3.0.STABLE16 to adapt to many kinds of systems.
 
 Usage: $0 [OPTION]... [VAR=VALUE]...
 
@@ -1733,7 +1738,7 @@
 
 if test -n "$ac_init_help"; then
   case $ac_init_help in
-     short | recursive ) echo "Configuration of Squid Web Proxy 3.0.STABLE16-RC1:";;
+     short | recursive ) echo "Configuration of Squid Web Proxy 3.0.STABLE16:";;
    esac
   cat <<\_ACEOF
 
@@ -2045,7 +2050,7 @@
 test -n "$ac_init_help" && exit $ac_status
 if $ac_init_version; then
   cat <<\_ACEOF
-Squid Web Proxy configure 3.0.STABLE16-RC1
+Squid Web Proxy configure 3.0.STABLE16
 generated by GNU Autoconf 2.62
 
 Copyright (C) 1992, 1993, 1994, 1995, 1996, 1998, 1999, 2000, 2001,
@@ -2059,7 +2064,7 @@
 This file contains any messages produced by compilers while
 running configure, to aid debugging if configure makes a mistake.
 
-It was created by Squid Web Proxy $as_me 3.0.STABLE16-RC1, which was
+It was created by Squid Web Proxy $as_me 3.0.STABLE16, which was
 generated by GNU Autoconf 2.62.  Invocation command line was
 
   $ $0 $@
@@ -2777,7 +2782,7 @@
 
 # Define the identity of the package.
  PACKAGE='squid'
- VERSION='3.0.STABLE16-RC1'
+ VERSION='3.0.STABLE16'
 
 
 cat >>confdefs.h <<_ACEOF
@@ -5538,7 +5543,7 @@
   ;;
 *-*-irix6*)
   # Find out which ABI we are using.
-  echo '#line 5541 "configure"' > conftest.$ac_ext
+  echo '#line 5546 "configure"' > conftest.$ac_ext
   if { (eval echo "$as_me:$LINENO: \"$ac_compile\"") >&5
   (eval $ac_compile) 2>&5
   ac_status=$?
@@ -8161,11 +8166,11 @@
    -e 's:.*FLAGS}\{0,1\} :&$lt_compiler_flag :; t' \
    -e 's: [^ ]*conftest\.: $lt_compiler_flag&:; t' \
    -e 's:$: $lt_compiler_flag:'`
-   (eval echo "\"\$as_me:8164: $lt_compile\"" >&5)
+   (eval echo "\"\$as_me:8169: $lt_compile\"" >&5)
    (eval "$lt_compile" 2>conftest.err)
    ac_status=$?
    cat conftest.err >&5
-   echo "$as_me:8168: \$? = $ac_status" >&5
+   echo "$as_me:8173: \$? = $ac_status" >&5
    if (exit $ac_status) && test -s "$ac_outfile"; then
      # The compiler can only warn and ignore the option if not recognized
      # So say no if there are warnings other than the usual output.
@@ -8451,11 +8456,11 @@
    -e 's:.*FLAGS}\{0,1\} :&$lt_compiler_flag :; t' \
    -e 's: [^ ]*conftest\.: $lt_compiler_flag&:; t' \
    -e 's:$: $lt_compiler_flag:'`
-   (eval echo "\"\$as_me:8454: $lt_compile\"" >&5)
+   (eval echo "\"\$as_me:8459: $lt_compile\"" >&5)
    (eval "$lt_compile" 2>conftest.err)
    ac_status=$?
    cat conftest.err >&5
-   echo "$as_me:8458: \$? = $ac_status" >&5
+   echo "$as_me:8463: \$? = $ac_status" >&5
    if (exit $ac_status) && test -s "$ac_outfile"; then
      # The compiler can only warn and ignore the option if not recognized
      # So say no if there are warnings other than the usual output.
@@ -8555,11 +8560,11 @@
    -e 's:.*FLAGS}\{0,1\} :&$lt_compiler_flag :; t' \
    -e 's: [^ ]*conftest\.: $lt_compiler_flag&:; t' \
    -e 's:$: $lt_compiler_flag:'`
-   (eval echo "\"\$as_me:8558: $lt_compile\"" >&5)
+   (eval echo "\"\$as_me:8563: $lt_compile\"" >&5)
    (eval "$lt_compile" 2>out/conftest.err)
    ac_status=$?
    cat out/conftest.err >&5
-   echo "$as_me:8562: \$? = $ac_status" >&5
+   echo "$as_me:8567: \$? = $ac_status" >&5
    if (exit $ac_status) && test -s out/conftest2.$ac_objext
    then
      # The compiler can only warn and ignore the option if not recognized
@@ -10955,7 +10960,7 @@
   lt_dlunknown=0; lt_dlno_uscore=1; lt_dlneed_uscore=2
   lt_status=$lt_dlunknown
   cat > conftest.$ac_ext <<EOF
-#line 10958 "configure"
+#line 10963 "configure"
 #include "confdefs.h"
 
 #if HAVE_DLFCN_H
@@ -11055,7 +11060,7 @@
   lt_dlunknown=0; lt_dlno_uscore=1; lt_dlneed_uscore=2
   lt_status=$lt_dlunknown
   cat > conftest.$ac_ext <<EOF
-#line 11058 "configure"
+#line 11063 "configure"
 #include "confdefs.h"
 
 #if HAVE_DLFCN_H
@@ -13464,11 +13469,11 @@
    -e 's:.*FLAGS}\{0,1\} :&$lt_compiler_flag :; t' \
    -e 's: [^ ]*conftest\.: $lt_compiler_flag&:; t' \
    -e 's:$: $lt_compiler_flag:'`
-   (eval echo "\"\$as_me:13467: $lt_compile\"" >&5)
+   (eval echo "\"\$as_me:13472: $lt_compile\"" >&5)
    (eval "$lt_compile" 2>conftest.err)
    ac_status=$?
    cat conftest.err >&5
-   echo "$as_me:13471: \$? = $ac_status" >&5
+   echo "$as_me:13476: \$? = $ac_status" >&5
    if (exit $ac_status) && test -s "$ac_outfile"; then
      # The compiler can only warn and ignore the option if not recognized
      # So say no if there are warnings other than the usual output.
@@ -13568,11 +13573,11 @@
    -e 's:.*FLAGS}\{0,1\} :&$lt_compiler_flag :; t' \
    -e 's: [^ ]*conftest\.: $lt_compiler_flag&:; t' \
    -e 's:$: $lt_compiler_flag:'`
-   (eval echo "\"\$as_me:13571: $lt_compile\"" >&5)
+   (eval echo "\"\$as_me:13576: $lt_compile\"" >&5)
    (eval "$lt_compile" 2>out/conftest.err)
    ac_status=$?
    cat out/conftest.err >&5
-   echo "$as_me:13575: \$? = $ac_status" >&5
+   echo "$as_me:13580: \$? = $ac_status" >&5
    if (exit $ac_status) && test -s out/conftest2.$ac_objext
    then
      # The compiler can only warn and ignore the option if not recognized
@@ -15151,11 +15156,11 @@
    -e 's:.*FLAGS}\{0,1\} :&$lt_compiler_flag :; t' \
    -e 's: [^ ]*conftest\.: $lt_compiler_flag&:; t' \
    -e 's:$: $lt_compiler_flag:'`
-   (eval echo "\"\$as_me:15154: $lt_compile\"" >&5)
+   (eval echo "\"\$as_me:15159: $lt_compile\"" >&5)
    (eval "$lt_compile" 2>conftest.err)
    ac_status=$?
    cat conftest.err >&5
-   echo "$as_me:15158: \$? = $ac_status" >&5
+   echo "$as_me:15163: \$? = $ac_status" >&5
    if (exit $ac_status) && test -s "$ac_outfile"; then
      # The compiler can only warn and ignore the option if not recognized
      # So say no if there are warnings other than the usual output.
@@ -15255,11 +15260,11 @@
    -e 's:.*FLAGS}\{0,1\} :&$lt_compiler_flag :; t' \
    -e 's: [^ ]*conftest\.: $lt_compiler_flag&:; t' \
    -e 's:$: $lt_compiler_flag:'`
-   (eval echo "\"\$as_me:15258: $lt_compile\"" >&5)
+   (eval echo "\"\$as_me:15263: $lt_compile\"" >&5)
    (eval "$lt_compile" 2>out/conftest.err)
    ac_status=$?
    cat out/conftest.err >&5
-   echo "$as_me:15262: \$? = $ac_status" >&5
+   echo "$as_me:15267: \$? = $ac_status" >&5
    if (exit $ac_status) && test -s out/conftest2.$ac_objext
    then
      # The compiler can only warn and ignore the option if not recognized
@@ -17470,11 +17475,11 @@
    -e 's:.*FLAGS}\{0,1\} :&$lt_compiler_flag :; t' \
    -e 's: [^ ]*conftest\.: $lt_compiler_flag&:; t' \
    -e 's:$: $lt_compiler_flag:'`
-   (eval echo "\"\$as_me:17473: $lt_compile\"" >&5)
+   (eval echo "\"\$as_me:17478: $lt_compile\"" >&5)
    (eval "$lt_compile" 2>conftest.err)
    ac_status=$?
    cat conftest.err >&5
-   echo "$as_me:17477: \$? = $ac_status" >&5
+   echo "$as_me:17482: \$? = $ac_status" >&5
    if (exit $ac_status) && test -s "$ac_outfile"; then
      # The compiler can only warn and ignore the option if not recognized
      # So say no if there are warnings other than the usual output.
@@ -17760,11 +17765,11 @@
    -e 's:.*FLAGS}\{0,1\} :&$lt_compiler_flag :; t' \
    -e 's: [^ ]*conftest\.: $lt_compiler_flag&:; t' \
    -e 's:$: $lt_compiler_flag:'`
-   (eval echo "\"\$as_me:17763: $lt_compile\"" >&5)
+   (eval echo "\"\$as_me:17768: $lt_compile\"" >&5)
    (eval "$lt_compile" 2>conftest.err)
    ac_status=$?
    cat conftest.err >&5
-   echo "$as_me:17767: \$? = $ac_status" >&5
+   echo "$as_me:17772: \$? = $ac_status" >&5
    if (exit $ac_status) && test -s "$ac_outfile"; then
      # The compiler can only warn and ignore the option if not recognized
      # So say no if there are warnings other than the usual output.
@@ -17864,11 +17869,11 @@
    -e 's:.*FLAGS}\{0,1\} :&$lt_compiler_flag :; t' \
    -e 's: [^ ]*conftest\.: $lt_compiler_flag&:; t' \
    -e 's:$: $lt_compiler_flag:'`
-   (eval echo "\"\$as_me:17867: $lt_compile\"" >&5)
+   (eval echo "\"\$as_me:17872: $lt_compile\"" >&5)
    (eval "$lt_compile" 2>out/conftest.err)
    ac_status=$?
    cat out/conftest.err >&5
-   echo "$as_me:17871: \$? = $ac_status" >&5
+   echo "$as_me:17876: \$? = $ac_status" >&5
    if (exit $ac_status) && test -s out/conftest2.$ac_objext
    then
      # The compiler can only warn and ignore the option if not recognized
@@ -23245,6 +23250,345 @@
 fi
 
 
+if `echo "$NEGOTIATE_AUTH_HELPERS" | $EGREP "squid_kerb_auth|all" >/dev/null`; then
+    # Extract the first word of "krb5-config", so it can be a program name with args.
+set dummy krb5-config; ac_word=$2
+{ $as_echo "$as_me:$LINENO: checking for $ac_word" >&5
+$as_echo_n "checking for $ac_word... " >&6; }
+if test "${ac_cv_prog_ac_krb5_config+set}" = set; then
+  $as_echo_n "(cached) " >&6
+else
+  if test -n "$ac_krb5_config"; then
+  ac_cv_prog_ac_krb5_config="$ac_krb5_config" # Let the user override the test.
+else
+as_save_IFS=$IFS; IFS=$PATH_SEPARATOR
+for as_dir in $PATH
+do
+  IFS=$as_save_IFS
+  test -z "$as_dir" && as_dir=.
+  for ac_exec_ext in '' $ac_executable_extensions; do
+  if { test -f "$as_dir/$ac_word$ac_exec_ext" && $as_test_x "$as_dir/$ac_word$ac_exec_ext"; }; then
+    ac_cv_prog_ac_krb5_config="yes"
+    $as_echo "$as_me:$LINENO: found $as_dir/$ac_word$ac_exec_ext" >&5
+    break 2
+  fi
+done
+done
+IFS=$as_save_IFS
+
+  test -z "$ac_cv_prog_ac_krb5_config" && ac_cv_prog_ac_krb5_config="no"
+fi
+fi
+ac_krb5_config=$ac_cv_prog_ac_krb5_config
+if test -n "$ac_krb5_config"; then
+  { $as_echo "$as_me:$LINENO: result: $ac_krb5_config" >&5
+$as_echo "$ac_krb5_config" >&6; }
+else
+  { $as_echo "$as_me:$LINENO: result: no" >&5
+$as_echo "no" >&6; }
+fi
+
+
+    if test "x$ac_krb5_config" = "xyes" ; then
+       ac_heimdal=`krb5-config --version 2>/dev/null | grep -i heimdal`
+       ac_solaris=`krb5-config --version 2>/dev/null | grep -i solaris`
+       if test "x$ac_heimdal" != "x" ; then
+
+cat >>confdefs.h <<\_ACEOF
+#define HAVE_HEIMDAL_KERBEROS 1
+_ACEOF
+
+       else
+
+cat >>confdefs.h <<\_ACEOF
+#define HAVE_MIT_KERBEROS 1
+_ACEOF
+
+       fi
+       if test "x$ac_solaris" != "x" ; then
+          KRB5INCS="-I/usr/include/gssapi"
+          KRB5LIBS="-L/usr/lib -R/usr/lib -lgss -lresolv -lsocket -lnsl"
+       else
+          KRB5INCS=`krb5-config --cflags gssapi 2>/dev/null`
+          KRB5LIBS=`krb5-config --libs gssapi 2>/dev/null`
+       fi
+
+
+
+
+for ac_header in gssapi.h gssapi/gssapi.h gssapi/gssapi_krb5.h gssapi/gssapi_generic.h
+do
+as_ac_Header=`$as_echo "ac_cv_header_$ac_header" | $as_tr_sh`
+if { as_var=$as_ac_Header; eval "test \"\${$as_var+set}\" = set"; }; then
+  { $as_echo "$as_me:$LINENO: checking for $ac_header" >&5
+$as_echo_n "checking for $ac_header... " >&6; }
+if { as_var=$as_ac_Header; eval "test \"\${$as_var+set}\" = set"; }; then
+  $as_echo_n "(cached) " >&6
+fi
+ac_res=`eval 'as_val=${'$as_ac_Header'}
+		 $as_echo "$as_val"'`
+	       { $as_echo "$as_me:$LINENO: result: $ac_res" >&5
+$as_echo "$ac_res" >&6; }
+else
+  # Is the header compilable?
+{ $as_echo "$as_me:$LINENO: checking $ac_header usability" >&5
+$as_echo_n "checking $ac_header usability... " >&6; }
+cat >conftest.$ac_ext <<_ACEOF
+/* confdefs.h.  */
+_ACEOF
+cat confdefs.h >>conftest.$ac_ext
+cat >>conftest.$ac_ext <<_ACEOF
+/* end confdefs.h.  */
+$ac_includes_default
+#include <$ac_header>
+_ACEOF
+rm -f conftest.$ac_objext
+if { (ac_try="$ac_compile"
+case "(($ac_try" in
+  *\"* | *\`* | *\\*) ac_try_echo=\$ac_try;;
+  *) ac_try_echo=$ac_try;;
+esac
+eval ac_try_echo="\"\$as_me:$LINENO: $ac_try_echo\""
+$as_echo "$ac_try_echo") >&5
+  (eval "$ac_compile") 2>conftest.er1
+  ac_status=$?
+  grep -v '^ *+' conftest.er1 >conftest.err
+  rm -f conftest.er1
+  cat conftest.err >&5
+  $as_echo "$as_me:$LINENO: \$? = $ac_status" >&5
+  (exit $ac_status); } && {
+	 test -z "$ac_c_werror_flag" ||
+	 test ! -s conftest.err
+       } && test -s conftest.$ac_objext; then
+  ac_header_compiler=yes
+else
+  $as_echo "$as_me: failed program was:" >&5
+sed 's/^/| /' conftest.$ac_ext >&5
+
+	ac_header_compiler=no
+fi
+
+rm -f core conftest.err conftest.$ac_objext conftest.$ac_ext
+{ $as_echo "$as_me:$LINENO: result: $ac_header_compiler" >&5
+$as_echo "$ac_header_compiler" >&6; }
+
+# Is the header present?
+{ $as_echo "$as_me:$LINENO: checking $ac_header presence" >&5
+$as_echo_n "checking $ac_header presence... " >&6; }
+cat >conftest.$ac_ext <<_ACEOF
+/* confdefs.h.  */
+_ACEOF
+cat confdefs.h >>conftest.$ac_ext
+cat >>conftest.$ac_ext <<_ACEOF
+/* end confdefs.h.  */
+#include <$ac_header>
+_ACEOF
+if { (ac_try="$ac_cpp conftest.$ac_ext"
+case "(($ac_try" in
+  *\"* | *\`* | *\\*) ac_try_echo=\$ac_try;;
+  *) ac_try_echo=$ac_try;;
+esac
+eval ac_try_echo="\"\$as_me:$LINENO: $ac_try_echo\""
+$as_echo "$ac_try_echo") >&5
+  (eval "$ac_cpp conftest.$ac_ext") 2>conftest.er1
+  ac_status=$?
+  grep -v '^ *+' conftest.er1 >conftest.err
+  rm -f conftest.er1
+  cat conftest.err >&5
+  $as_echo "$as_me:$LINENO: \$? = $ac_status" >&5
+  (exit $ac_status); } >/dev/null && {
+	 test -z "$ac_c_preproc_warn_flag$ac_c_werror_flag" ||
+	 test ! -s conftest.err
+       }; then
+  ac_header_preproc=yes
+else
+  $as_echo "$as_me: failed program was:" >&5
+sed 's/^/| /' conftest.$ac_ext >&5
+
+  ac_header_preproc=no
+fi
+
+rm -f conftest.err conftest.$ac_ext
+{ $as_echo "$as_me:$LINENO: result: $ac_header_preproc" >&5
+$as_echo "$ac_header_preproc" >&6; }
+
+# So?  What about this header?
+case $ac_header_compiler:$ac_header_preproc:$ac_c_preproc_warn_flag in
+  yes:no: )
+    { $as_echo "$as_me:$LINENO: WARNING: $ac_header: accepted by the compiler, rejected by the preprocessor!" >&5
+$as_echo "$as_me: WARNING: $ac_header: accepted by the compiler, rejected by the preprocessor!" >&2;}
+    { $as_echo "$as_me:$LINENO: WARNING: $ac_header: proceeding with the compiler's result" >&5
+$as_echo "$as_me: WARNING: $ac_header: proceeding with the compiler's result" >&2;}
+    ac_header_preproc=yes
+    ;;
+  no:yes:* )
+    { $as_echo "$as_me:$LINENO: WARNING: $ac_header: present but cannot be compiled" >&5
+$as_echo "$as_me: WARNING: $ac_header: present but cannot be compiled" >&2;}
+    { $as_echo "$as_me:$LINENO: WARNING: $ac_header:     check for missing prerequisite headers?" >&5
+$as_echo "$as_me: WARNING: $ac_header:     check for missing prerequisite headers?" >&2;}
+    { $as_echo "$as_me:$LINENO: WARNING: $ac_header: see the Autoconf documentation" >&5
+$as_echo "$as_me: WARNING: $ac_header: see the Autoconf documentation" >&2;}
+    { $as_echo "$as_me:$LINENO: WARNING: $ac_header:     section \"Present But Cannot Be Compiled\"" >&5
+$as_echo "$as_me: WARNING: $ac_header:     section \"Present But Cannot Be Compiled\"" >&2;}
+    { $as_echo "$as_me:$LINENO: WARNING: $ac_header: proceeding with the preprocessor's result" >&5
+$as_echo "$as_me: WARNING: $ac_header: proceeding with the preprocessor's result" >&2;}
+    { $as_echo "$as_me:$LINENO: WARNING: $ac_header: in the future, the compiler will take precedence" >&5
+$as_echo "$as_me: WARNING: $ac_header: in the future, the compiler will take precedence" >&2;}
+    ( cat <<\_ASBOX
+## ----------------------------------------------- ##
+## Report this to http://www.squid-cache.org/bugs/ ##
+## ----------------------------------------------- ##
+_ASBOX
+     ) | sed "s/^/$as_me: WARNING:     /" >&2
+    ;;
+esac
+{ $as_echo "$as_me:$LINENO: checking for $ac_header" >&5
+$as_echo_n "checking for $ac_header... " >&6; }
+if { as_var=$as_ac_Header; eval "test \"\${$as_var+set}\" = set"; }; then
+  $as_echo_n "(cached) " >&6
+else
+  eval "$as_ac_Header=\$ac_header_preproc"
+fi
+ac_res=`eval 'as_val=${'$as_ac_Header'}
+		 $as_echo "$as_val"'`
+	       { $as_echo "$as_me:$LINENO: result: $ac_res" >&5
+$as_echo "$ac_res" >&6; }
+
+fi
+if test `eval 'as_val=${'$as_ac_Header'}
+		 $as_echo "$as_val"'` = yes; then
+  cat >>confdefs.h <<_ACEOF
+#define `$as_echo "HAVE_$ac_header" | $as_tr_cpp` 1
+_ACEOF
+
+fi
+
+done
+
+    fi
+    old_CPPFLAGS=$CPPFLAGS
+    CPPFLAGS="$CPPFLAGS $KRB5INCS"
+    old_LIBS=$LIBS
+    LIBS="$LIBS $KRB5LIBS"
+    { $as_echo "$as_me:$LINENO: checking for SPNEGO support" >&5
+$as_echo_n "checking for SPNEGO support... " >&6; }
+if test "${ac_cv_have_spnego+set}" = set; then
+  $as_echo_n "(cached) " >&6
+else
+
+    if test "$cross_compiling" = yes; then
+  { { $as_echo "$as_me:$LINENO: error: cannot run test program while cross compiling
+See \`config.log' for more details." >&5
+$as_echo "$as_me: error: cannot run test program while cross compiling
+See \`config.log' for more details." >&2;}
+   { (exit 1); exit 1; }; }
+else
+  cat >conftest.$ac_ext <<_ACEOF
+/* confdefs.h.  */
+_ACEOF
+cat confdefs.h >>conftest.$ac_ext
+cat >>conftest.$ac_ext <<_ACEOF
+/* end confdefs.h.  */
+
+#ifdef HAVE_HEIMDAL_KERBEROS
+#ifdef HAVE_GSSAPI_GSSAPI_H
+#include <gssapi/gssapi.h>
+#elif defined(HAVE_GSSAPI_H)
+#include <gssapi.h>
+#endif
+#else
+#ifdef HAVE_GSSAPI_GSSAPI_H
+#include <gssapi/gssapi.h>
+#elif defined(HAVE_GSSAPI_H)
+#include <gssapi.h>
+#endif
+#ifdef HAVE_GSSAPI_GSSAPI_KRB5_H
+#include <gssapi/gssapi_krb5.h>
+#endif
+#ifdef HAVE_GSSAPI_GSSAPI_GENERIC_H
+#include <gssapi/gssapi_generic.h>
+#endif
+#endif
+#include <string.h>
+int main(int argc, char *argv[]) {
+ OM_uint32 major_status,minor_status;
+ gss_OID_set gss_mech_set;
+ int i;
+
+static gss_OID_desc _gss_mech_spnego  = {6, (void *)"\x2b\x06\x01\x05\x05\x02"};
+gss_OID gss_mech_spnego = &_gss_mech_spnego;
+
+ major_status = gss_indicate_mechs( &minor_status, &gss_mech_set);
+
+ for (i=0;i<gss_mech_set->count;i++) {
+     if (!memcmp(gss_mech_set->elements[i].elements,gss_mech_spnego->elements,gss_mech_set->elements[i].length)) {
+        return 0;
+     }
+ }
+
+ return 1;
+}
+_ACEOF
+rm -f conftest$ac_exeext
+if { (ac_try="$ac_link"
+case "(($ac_try" in
+  *\"* | *\`* | *\\*) ac_try_echo=\$ac_try;;
+  *) ac_try_echo=$ac_try;;
+esac
+eval ac_try_echo="\"\$as_me:$LINENO: $ac_try_echo\""
+$as_echo "$ac_try_echo") >&5
+  (eval "$ac_link") 2>&5
+  ac_status=$?
+  $as_echo "$as_me:$LINENO: \$? = $ac_status" >&5
+  (exit $ac_status); } && { ac_try='./conftest$ac_exeext'
+  { (case "(($ac_try" in
+  *\"* | *\`* | *\\*) ac_try_echo=\$ac_try;;
+  *) ac_try_echo=$ac_try;;
+esac
+eval ac_try_echo="\"\$as_me:$LINENO: $ac_try_echo\""
+$as_echo "$ac_try_echo") >&5
+  (eval "$ac_try") 2>&5
+  ac_status=$?
+  $as_echo "$as_me:$LINENO: \$? = $ac_status" >&5
+  (exit $ac_status); }; }; then
+  ac_cv_have_spnego=yes
+else
+  $as_echo "$as_me: program exited with status $ac_status" >&5
+$as_echo "$as_me: failed program was:" >&5
+sed 's/^/| /' conftest.$ac_ext >&5
+
+( exit $ac_status )
+ac_cv_have_spnego=no
+fi
+rm -rf conftest.dSYM
+rm -f core *.core core.conftest.* gmon.out bb.out conftest$ac_exeext conftest.$ac_objext conftest.$ac_ext
+fi
+
+
+fi
+{ $as_echo "$as_me:$LINENO: result: $ac_cv_have_spnego" >&5
+$as_echo "$ac_cv_have_spnego" >&6; }
+  LIBS=$old_LIBS
+  CPPFLAGS=$old_CPPFLAGS
+  if test x"$ac_cv_have_spnego" = x"yes"; then
+
+cat >>confdefs.h <<\_ACEOF
+#define HAVE_SPNEGO 1
+_ACEOF
+
+  fi
+
+
+fi
+ if test x"$ac_cv_have_spnego" = x"yes" ; then
+  HAVE_SPNEGO_TRUE=
+  HAVE_SPNEGO_FALSE='#'
+else
+  HAVE_SPNEGO_TRUE='#'
+  HAVE_SPNEGO_FALSE=
+fi
+
+
 # Check whether --enable-ntlm-fail-open was given.
 if test "${enable_ntlm_fail_open+set}" = set; then
   enableval=$enable_ntlm_fail_open;  if test "$enableval" = "yes" ; then
@@ -47375,6 +47719,13 @@
 Usually this means the macro was only invoked conditionally." >&2;}
    { (exit 1); exit 1; }; }
 fi
+if test -z "${HAVE_SPNEGO_TRUE}" && test -z "${HAVE_SPNEGO_FALSE}"; then
+  { { $as_echo "$as_me:$LINENO: error: conditional \"HAVE_SPNEGO\" was never defined.
+Usually this means the macro was only invoked conditionally." >&5
+$as_echo "$as_me: error: conditional \"HAVE_SPNEGO\" was never defined.
+Usually this means the macro was only invoked conditionally." >&2;}
+   { (exit 1); exit 1; }; }
+fi
 if test -z "${ENABLE_UNLINKD_TRUE}" && test -z "${ENABLE_UNLINKD_FALSE}"; then
   { { $as_echo "$as_me:$LINENO: error: conditional \"ENABLE_UNLINKD\" was never defined.
 Usually this means the macro was only invoked conditionally." >&5
@@ -47802,7 +48153,7 @@
 # report actual input values of CONFIG_FILES etc. instead of their
 # values after options handling.
 ac_log="
-This file was extended by Squid Web Proxy $as_me 3.0.STABLE16-RC1, which was
+This file was extended by Squid Web Proxy $as_me 3.0.STABLE16, which was
 generated by GNU Autoconf 2.62.  Invocation command line was
 
   CONFIG_FILES    = $CONFIG_FILES
@@ -47855,7 +48206,7 @@
 _ACEOF
 cat >>$CONFIG_STATUS <<_ACEOF || ac_write_fail=1
 ac_cs_version="\\
-Squid Web Proxy config.status 3.0.STABLE16-RC1
+Squid Web Proxy config.status 3.0.STABLE16
 configured by $0, generated by GNU Autoconf 2.62,
   with options \\"`$as_echo "$ac_configure_args" | sed 's/^ //; s/[\\""\`\$]/\\\\&/g'`\\"
 
diff -u -r -N squid-3.0.STABLE16-RC1/configure.in squid-3.0.STABLE16/configure.in
--- squid-3.0.STABLE16-RC1/configure.in	2009-05-16 00:47:59.000000000 +1200
+++ squid-3.0.STABLE16/configure.in	2009-06-15 19:31:33.000000000 +1200
@@ -1,7 +1,7 @@
 dnl  Configuration input file for Squid
 dnl
 dnl
-AC_INIT(Squid Web Proxy, 3.0.STABLE16-RC1, http://www.squid-cache.org/bugs/, squid)
+AC_INIT(Squid Web Proxy, 3.0.STABLE16, http://www.squid-cache.org/bugs/, squid)
 AC_PREREQ(2.52)
 AM_CONFIG_HEADER(include/autoconf.h)
 AC_CONFIG_AUX_DIR(cfgaux)
@@ -1575,6 +1575,81 @@
 fi
 AC_SUBST(DIGEST_AUTH_HELPERS)
 
+if `echo "$NEGOTIATE_AUTH_HELPERS" | $EGREP "squid_kerb_auth|all" >/dev/null`; then
+    AC_CHECK_PROG(ac_krb5_config,krb5-config,yes,no)
+    if test "x$ac_krb5_config" = "xyes" ; then
+       ac_heimdal=`krb5-config --version 2>/dev/null | grep -i heimdal`
+       ac_solaris=`krb5-config --version 2>/dev/null | grep -i solaris`
+       if test "x$ac_heimdal" != "x" ; then
+          AC_DEFINE(HAVE_HEIMDAL_KERBEROS,1,[Define to 1 if you have Heimdal Kerberos])
+       else
+          AC_DEFINE(HAVE_MIT_KERBEROS,1,[Define to 1 if you have MIT Kerberos])
+       fi
+       if test "x$ac_solaris" != "x" ; then
+          KRB5INCS="-I/usr/include/gssapi"
+          KRB5LIBS="-L/usr/lib -R/usr/lib -lgss -lresolv -lsocket -lnsl"
+       else
+          KRB5INCS=`krb5-config --cflags gssapi 2>/dev/null` 
+          KRB5LIBS=`krb5-config --libs gssapi 2>/dev/null` 
+       fi
+       AC_CHECK_HEADERS(gssapi.h gssapi/gssapi.h gssapi/gssapi_krb5.h gssapi/gssapi_generic.h)
+    fi
+    old_CPPFLAGS=$CPPFLAGS
+    CPPFLAGS="$CPPFLAGS $KRB5INCS"
+    old_LIBS=$LIBS
+    LIBS="$LIBS $KRB5LIBS"
+    AC_CACHE_CHECK([for SPNEGO support],ac_cv_have_spnego,[
+    AC_TRY_RUN([
+#ifdef HAVE_HEIMDAL_KERBEROS
+#ifdef HAVE_GSSAPI_GSSAPI_H
+#include <gssapi/gssapi.h>
+#elif defined(HAVE_GSSAPI_H)
+#include <gssapi.h>
+#endif
+#else
+#ifdef HAVE_GSSAPI_GSSAPI_H
+#include <gssapi/gssapi.h>
+#elif defined(HAVE_GSSAPI_H)
+#include <gssapi.h>
+#endif
+#ifdef HAVE_GSSAPI_GSSAPI_KRB5_H
+#include <gssapi/gssapi_krb5.h>
+#endif
+#ifdef HAVE_GSSAPI_GSSAPI_GENERIC_H
+#include <gssapi/gssapi_generic.h>
+#endif
+#endif
+#include <string.h>
+int main(int argc, char *argv[]) {
+ OM_uint32 major_status,minor_status;
+ gss_OID_set gss_mech_set;
+ int i;
+
+static gss_OID_desc _gss_mech_spnego  = {6, (void *)"\x2b\x06\x01\x05\x05\x02"};
+gss_OID gss_mech_spnego = &_gss_mech_spnego;
+
+ major_status = gss_indicate_mechs( &minor_status, &gss_mech_set);
+
+ for (i=0;i<gss_mech_set->count;i++) {
+     if (!memcmp(gss_mech_set->elements[i].elements,gss_mech_spnego->elements,gss_mech_set->elements[i].length)) {
+        return 0;
+     }
+ }
+
+ return 1;
+}],
+  ac_cv_have_spnego=yes,
+  ac_cv_have_spnego=no)])
+  LIBS=$old_LIBS
+  CPPFLAGS=$old_CPPFLAGS
+  if test x"$ac_cv_have_spnego" = x"yes"; then
+    AC_DEFINE(HAVE_SPNEGO,1, [Define to 1 if you have SPNEGO support])
+  fi
+  AC_SUBST(KRB5INCS)
+  AC_SUBST(KRB5LIBS)
+fi
+AM_CONDITIONAL(HAVE_SPNEGO, test x"$ac_cv_have_spnego" = x"yes" )
+
 dnl Enable "NTLM fail open"
 AC_ARG_ENABLE(ntlm-fail-open,
 [  --enable-ntlm-fail-open Enable NTLM fail open, where a helper that fails one of the
diff -u -r -N squid-3.0.STABLE16-RC1/contrib/Makefile.in squid-3.0.STABLE16/contrib/Makefile.in
--- squid-3.0.STABLE16-RC1/contrib/Makefile.in	2009-05-16 00:47:47.000000000 +1200
+++ squid-3.0.STABLE16/contrib/Makefile.in	2009-06-15 19:31:06.000000000 +1200
@@ -106,6 +106,8 @@
 INSTALL_PROGRAM = @INSTALL_PROGRAM@
 INSTALL_SCRIPT = @INSTALL_SCRIPT@
 INSTALL_STRIP_PROGRAM = @INSTALL_STRIP_PROGRAM@
+KRB5INCS = @KRB5INCS@
+KRB5LIBS = @KRB5LIBS@
 LDFLAGS = @LDFLAGS@
 LIBADD_DL = @LIBADD_DL@
 LIBOBJS = @LIBOBJS@
@@ -172,6 +174,7 @@
 ac_ct_CC = @ac_ct_CC@
 ac_ct_CXX = @ac_ct_CXX@
 ac_ct_F77 = @ac_ct_F77@
+ac_krb5_config = @ac_krb5_config@
 am__include = @am__include@
 am__leading_dot = @am__leading_dot@
 am__quote = @am__quote@
diff -u -r -N squid-3.0.STABLE16-RC1/doc/Makefile.in squid-3.0.STABLE16/doc/Makefile.in
--- squid-3.0.STABLE16-RC1/doc/Makefile.in	2009-05-16 00:47:47.000000000 +1200
+++ squid-3.0.STABLE16/doc/Makefile.in	2009-06-15 19:31:06.000000000 +1200
@@ -113,6 +113,8 @@
 INSTALL_PROGRAM = @INSTALL_PROGRAM@
 INSTALL_SCRIPT = @INSTALL_SCRIPT@
 INSTALL_STRIP_PROGRAM = @INSTALL_STRIP_PROGRAM@
+KRB5INCS = @KRB5INCS@
+KRB5LIBS = @KRB5LIBS@
 LDFLAGS = @LDFLAGS@
 LIBADD_DL = @LIBADD_DL@
 LIBOBJS = @LIBOBJS@
@@ -179,6 +181,7 @@
 ac_ct_CC = @ac_ct_CC@
 ac_ct_CXX = @ac_ct_CXX@
 ac_ct_F77 = @ac_ct_F77@
+ac_krb5_config = @ac_krb5_config@
 am__include = @am__include@
 am__leading_dot = @am__leading_dot@
 am__quote = @am__quote@
diff -u -r -N squid-3.0.STABLE16-RC1/errors/Makefile.in squid-3.0.STABLE16/errors/Makefile.in
--- squid-3.0.STABLE16-RC1/errors/Makefile.in	2009-05-16 00:47:50.000000000 +1200
+++ squid-3.0.STABLE16/errors/Makefile.in	2009-06-15 19:31:11.000000000 +1200
@@ -105,6 +105,8 @@
 INSTALL_PROGRAM = @INSTALL_PROGRAM@
 INSTALL_SCRIPT = @INSTALL_SCRIPT@
 INSTALL_STRIP_PROGRAM = @INSTALL_STRIP_PROGRAM@
+KRB5INCS = @KRB5INCS@
+KRB5LIBS = @KRB5LIBS@
 LDFLAGS = @LDFLAGS@
 LIBADD_DL = @LIBADD_DL@
 LIBOBJS = @LIBOBJS@
@@ -171,6 +173,7 @@
 ac_ct_CC = @ac_ct_CC@
 ac_ct_CXX = @ac_ct_CXX@
 ac_ct_F77 = @ac_ct_F77@
+ac_krb5_config = @ac_krb5_config@
 am__include = @am__include@
 am__leading_dot = @am__leading_dot@
 am__quote = @am__quote@
diff -u -r -N squid-3.0.STABLE16-RC1/helpers/basic_auth/DB/Makefile.in squid-3.0.STABLE16/helpers/basic_auth/DB/Makefile.in
--- squid-3.0.STABLE16-RC1/helpers/basic_auth/DB/Makefile.in	2009-05-16 00:47:51.000000000 +1200
+++ squid-3.0.STABLE16/helpers/basic_auth/DB/Makefile.in	2009-06-15 19:31:13.000000000 +1200
@@ -116,6 +116,8 @@
 INSTALL_PROGRAM = @INSTALL_PROGRAM@
 INSTALL_SCRIPT = @INSTALL_SCRIPT@
 INSTALL_STRIP_PROGRAM = @INSTALL_STRIP_PROGRAM@
+KRB5INCS = @KRB5INCS@
+KRB5LIBS = @KRB5LIBS@
 LDFLAGS = @LDFLAGS@
 LIBADD_DL = @LIBADD_DL@
 LIBOBJS = @LIBOBJS@
@@ -182,6 +184,7 @@
 ac_ct_CC = @ac_ct_CC@
 ac_ct_CXX = @ac_ct_CXX@
 ac_ct_F77 = @ac_ct_F77@
+ac_krb5_config = @ac_krb5_config@
 am__include = @am__include@
 am__leading_dot = @am__leading_dot@
 am__quote = @am__quote@
diff -u -r -N squid-3.0.STABLE16-RC1/helpers/basic_auth/getpwnam/Makefile.in squid-3.0.STABLE16/helpers/basic_auth/getpwnam/Makefile.in
--- squid-3.0.STABLE16-RC1/helpers/basic_auth/getpwnam/Makefile.in	2009-05-16 00:47:51.000000000 +1200
+++ squid-3.0.STABLE16/helpers/basic_auth/getpwnam/Makefile.in	2009-06-15 19:31:14.000000000 +1200
@@ -134,6 +134,8 @@
 INSTALL_PROGRAM = @INSTALL_PROGRAM@
 INSTALL_SCRIPT = @INSTALL_SCRIPT@
 INSTALL_STRIP_PROGRAM = @INSTALL_STRIP_PROGRAM@
+KRB5INCS = @KRB5INCS@
+KRB5LIBS = @KRB5LIBS@
 LDFLAGS = @LDFLAGS@
 LIBADD_DL = @LIBADD_DL@
 LIBOBJS = @LIBOBJS@
@@ -200,6 +202,7 @@
 ac_ct_CC = @ac_ct_CC@
 ac_ct_CXX = @ac_ct_CXX@
 ac_ct_F77 = @ac_ct_F77@
+ac_krb5_config = @ac_krb5_config@
 am__include = @am__include@
 am__leading_dot = @am__leading_dot@
 am__quote = @am__quote@
diff -u -r -N squid-3.0.STABLE16-RC1/helpers/basic_auth/LDAP/Makefile.in squid-3.0.STABLE16/helpers/basic_auth/LDAP/Makefile.in
--- squid-3.0.STABLE16-RC1/helpers/basic_auth/LDAP/Makefile.in	2009-05-16 00:47:51.000000000 +1200
+++ squid-3.0.STABLE16/helpers/basic_auth/LDAP/Makefile.in	2009-06-15 19:31:13.000000000 +1200
@@ -137,6 +137,8 @@
 INSTALL_PROGRAM = @INSTALL_PROGRAM@
 INSTALL_SCRIPT = @INSTALL_SCRIPT@
 INSTALL_STRIP_PROGRAM = @INSTALL_STRIP_PROGRAM@
+KRB5INCS = @KRB5INCS@
+KRB5LIBS = @KRB5LIBS@
 LDFLAGS = @LDFLAGS@
 LIBADD_DL = @LIBADD_DL@
 LIBOBJS = @LIBOBJS@
@@ -203,6 +205,7 @@
 ac_ct_CC = @ac_ct_CC@
 ac_ct_CXX = @ac_ct_CXX@
 ac_ct_F77 = @ac_ct_F77@
+ac_krb5_config = @ac_krb5_config@
 am__include = @am__include@
 am__leading_dot = @am__leading_dot@
 am__quote = @am__quote@
diff -u -r -N squid-3.0.STABLE16-RC1/helpers/basic_auth/Makefile.in squid-3.0.STABLE16/helpers/basic_auth/Makefile.in
--- squid-3.0.STABLE16-RC1/helpers/basic_auth/Makefile.in	2009-05-16 00:47:51.000000000 +1200
+++ squid-3.0.STABLE16/helpers/basic_auth/Makefile.in	2009-06-15 19:31:13.000000000 +1200
@@ -117,6 +117,8 @@
 INSTALL_PROGRAM = @INSTALL_PROGRAM@
 INSTALL_SCRIPT = @INSTALL_SCRIPT@
 INSTALL_STRIP_PROGRAM = @INSTALL_STRIP_PROGRAM@
+KRB5INCS = @KRB5INCS@
+KRB5LIBS = @KRB5LIBS@
 LDFLAGS = @LDFLAGS@
 LIBADD_DL = @LIBADD_DL@
 LIBOBJS = @LIBOBJS@
@@ -183,6 +185,7 @@
 ac_ct_CC = @ac_ct_CC@
 ac_ct_CXX = @ac_ct_CXX@
 ac_ct_F77 = @ac_ct_F77@
+ac_krb5_config = @ac_krb5_config@
 am__include = @am__include@
 am__leading_dot = @am__leading_dot@
 am__quote = @am__quote@
diff -u -r -N squid-3.0.STABLE16-RC1/helpers/basic_auth/MSNT/Makefile.in squid-3.0.STABLE16/helpers/basic_auth/MSNT/Makefile.in
--- squid-3.0.STABLE16-RC1/helpers/basic_auth/MSNT/Makefile.in	2009-05-16 00:47:51.000000000 +1200
+++ squid-3.0.STABLE16/helpers/basic_auth/MSNT/Makefile.in	2009-06-15 19:31:13.000000000 +1200
@@ -146,6 +146,8 @@
 INSTALL_PROGRAM = @INSTALL_PROGRAM@
 INSTALL_SCRIPT = @INSTALL_SCRIPT@
 INSTALL_STRIP_PROGRAM = @INSTALL_STRIP_PROGRAM@
+KRB5INCS = @KRB5INCS@
+KRB5LIBS = @KRB5LIBS@
 LDFLAGS = @LDFLAGS@
 LIBADD_DL = @LIBADD_DL@
 LIBOBJS = @LIBOBJS@
@@ -212,6 +214,7 @@
 ac_ct_CC = @ac_ct_CC@
 ac_ct_CXX = @ac_ct_CXX@
 ac_ct_F77 = @ac_ct_F77@
+ac_krb5_config = @ac_krb5_config@
 am__include = @am__include@
 am__leading_dot = @am__leading_dot@
 am__quote = @am__quote@
diff -u -r -N squid-3.0.STABLE16-RC1/helpers/basic_auth/MSNT/msntauth.c squid-3.0.STABLE16/helpers/basic_auth/MSNT/msntauth.c
--- squid-3.0.STABLE16-RC1/helpers/basic_auth/MSNT/msntauth.c	2009-05-16 00:47:51.000000000 +1200
+++ squid-3.0.STABLE16/helpers/basic_auth/MSNT/msntauth.c	2009-06-15 19:31:13.000000000 +1200
@@ -73,10 +73,13 @@
     if ((Read_denyusers() == 1) || (Read_allowusers() == 1)) {
 	while (1) {
 	    memset(wstr, '\0', sizeof(wstr));
-	    fgets(wstr, 255, stdin);
+            if (fgets(wstr, 255, stdin) == NULL)
+                break;
 	    puts("ERR");
 	}
+        return 1;
     }
+
     /*
      * Make Check_forchange() the handle for HUP signals.
      * Don't use alarms any more. I don't think it was very
@@ -98,7 +101,9 @@
 	}
 	if (err) {
 	    syslog(LOG_WARNING, "oversized message");
-	    goto error;
+	    puts("ERR");
+            err = 0;
+            continue;
 	}
 
 	/*
@@ -114,8 +119,8 @@
 	}
 	/* Check for invalid or blank entries */
 	if ((username[0] == '\0') || (password[0] == '\0')) {
-	    puts("ERR");
-	    continue;
+            puts("ERR");
+            continue;
 	}
 	Checktimer();		/* Check if the user lists have changed */
 
@@ -133,10 +138,9 @@
 	    puts("OK");
 	else {
 	    syslog(LOG_INFO, "'%s' login failed", username);
-error:
-	    puts("ERR");
+            puts("ERR");
 	}
-	err = 0;
+        err = 0;
     }
 
     return 0;
diff -u -r -N squid-3.0.STABLE16-RC1/helpers/basic_auth/mswin_sspi/Makefile.in squid-3.0.STABLE16/helpers/basic_auth/mswin_sspi/Makefile.in
--- squid-3.0.STABLE16-RC1/helpers/basic_auth/mswin_sspi/Makefile.in	2009-05-16 00:47:51.000000000 +1200
+++ squid-3.0.STABLE16/helpers/basic_auth/mswin_sspi/Makefile.in	2009-06-15 19:31:14.000000000 +1200
@@ -133,6 +133,8 @@
 INSTALL_PROGRAM = @INSTALL_PROGRAM@
 INSTALL_SCRIPT = @INSTALL_SCRIPT@
 INSTALL_STRIP_PROGRAM = @INSTALL_STRIP_PROGRAM@
+KRB5INCS = @KRB5INCS@
+KRB5LIBS = @KRB5LIBS@
 LDFLAGS = @LDFLAGS@
 LIBADD_DL = @LIBADD_DL@
 LIBOBJS = @LIBOBJS@
@@ -199,6 +201,7 @@
 ac_ct_CC = @ac_ct_CC@
 ac_ct_CXX = @ac_ct_CXX@
 ac_ct_F77 = @ac_ct_F77@
+ac_krb5_config = @ac_krb5_config@
 am__include = @am__include@
 am__leading_dot = @am__leading_dot@
 am__quote = @am__quote@
diff -u -r -N squid-3.0.STABLE16-RC1/helpers/basic_auth/multi-domain-NTLM/Makefile.in squid-3.0.STABLE16/helpers/basic_auth/multi-domain-NTLM/Makefile.in
--- squid-3.0.STABLE16-RC1/helpers/basic_auth/multi-domain-NTLM/Makefile.in	2009-05-16 00:47:51.000000000 +1200
+++ squid-3.0.STABLE16/helpers/basic_auth/multi-domain-NTLM/Makefile.in	2009-06-15 19:31:14.000000000 +1200
@@ -113,6 +113,8 @@
 INSTALL_PROGRAM = @INSTALL_PROGRAM@
 INSTALL_SCRIPT = @INSTALL_SCRIPT@
 INSTALL_STRIP_PROGRAM = @INSTALL_STRIP_PROGRAM@
+KRB5INCS = @KRB5INCS@
+KRB5LIBS = @KRB5LIBS@
 LDFLAGS = @LDFLAGS@
 LIBADD_DL = @LIBADD_DL@
 LIBOBJS = @LIBOBJS@
@@ -179,6 +181,7 @@
 ac_ct_CC = @ac_ct_CC@
 ac_ct_CXX = @ac_ct_CXX@
 ac_ct_F77 = @ac_ct_F77@
+ac_krb5_config = @ac_krb5_config@
 am__include = @am__include@
 am__leading_dot = @am__leading_dot@
 am__quote = @am__quote@
diff -u -r -N squid-3.0.STABLE16-RC1/helpers/basic_auth/NCSA/Makefile.in squid-3.0.STABLE16/helpers/basic_auth/NCSA/Makefile.in
--- squid-3.0.STABLE16-RC1/helpers/basic_auth/NCSA/Makefile.in	2009-05-16 00:47:51.000000000 +1200
+++ squid-3.0.STABLE16/helpers/basic_auth/NCSA/Makefile.in	2009-06-15 19:31:13.000000000 +1200
@@ -137,6 +137,8 @@
 INSTALL_PROGRAM = @INSTALL_PROGRAM@
 INSTALL_SCRIPT = @INSTALL_SCRIPT@
 INSTALL_STRIP_PROGRAM = @INSTALL_STRIP_PROGRAM@
+KRB5INCS = @KRB5INCS@
+KRB5LIBS = @KRB5LIBS@
 LDFLAGS = @LDFLAGS@
 LIBADD_DL = @LIBADD_DL@
 LIBOBJS = @LIBOBJS@
@@ -203,6 +205,7 @@
 ac_ct_CC = @ac_ct_CC@
 ac_ct_CXX = @ac_ct_CXX@
 ac_ct_F77 = @ac_ct_F77@
+ac_krb5_config = @ac_krb5_config@
 am__include = @am__include@
 am__leading_dot = @am__leading_dot@
 am__quote = @am__quote@
diff -u -r -N squid-3.0.STABLE16-RC1/helpers/basic_auth/PAM/Makefile.in squid-3.0.STABLE16/helpers/basic_auth/PAM/Makefile.in
--- squid-3.0.STABLE16-RC1/helpers/basic_auth/PAM/Makefile.in	2009-05-16 00:47:51.000000000 +1200
+++ squid-3.0.STABLE16/helpers/basic_auth/PAM/Makefile.in	2009-06-15 19:31:14.000000000 +1200
@@ -136,6 +136,8 @@
 INSTALL_PROGRAM = @INSTALL_PROGRAM@
 INSTALL_SCRIPT = @INSTALL_SCRIPT@
 INSTALL_STRIP_PROGRAM = @INSTALL_STRIP_PROGRAM@
+KRB5INCS = @KRB5INCS@
+KRB5LIBS = @KRB5LIBS@
 LDFLAGS = @LDFLAGS@
 LIBADD_DL = @LIBADD_DL@
 LIBOBJS = @LIBOBJS@
@@ -202,6 +204,7 @@
 ac_ct_CC = @ac_ct_CC@
 ac_ct_CXX = @ac_ct_CXX@
 ac_ct_F77 = @ac_ct_F77@
+ac_krb5_config = @ac_krb5_config@
 am__include = @am__include@
 am__leading_dot = @am__leading_dot@
 am__quote = @am__quote@
diff -u -r -N squid-3.0.STABLE16-RC1/helpers/basic_auth/PAM/pam_auth.8 squid-3.0.STABLE16/helpers/basic_auth/PAM/pam_auth.8
--- squid-3.0.STABLE16-RC1/helpers/basic_auth/PAM/pam_auth.8	2009-05-16 00:47:51.000000000 +1200
+++ squid-3.0.STABLE16/helpers/basic_auth/PAM/pam_auth.8	2009-06-15 19:31:14.000000000 +1200
@@ -19,7 +19,7 @@
 .BI "-t " TTL
 Enables persistent PAM connections where the connection to the PAM
 database is kept open and reused for new logins. The TTL specifies
-how long the connetion will be kept open (in seconds).  Default is
+how long the connection will be kept open (in seconds).  Default is
 to not keep PAM connections open. Please note that the use of
 persistent PAM connections is slightly outside the PAM
 specification and may not work with all PAM configurations.
diff -u -r -N squid-3.0.STABLE16-RC1/helpers/basic_auth/POP3/Makefile.in squid-3.0.STABLE16/helpers/basic_auth/POP3/Makefile.in
--- squid-3.0.STABLE16-RC1/helpers/basic_auth/POP3/Makefile.in	2009-05-16 00:47:51.000000000 +1200
+++ squid-3.0.STABLE16/helpers/basic_auth/POP3/Makefile.in	2009-06-15 19:31:14.000000000 +1200
@@ -113,6 +113,8 @@
 INSTALL_PROGRAM = @INSTALL_PROGRAM@
 INSTALL_SCRIPT = @INSTALL_SCRIPT@
 INSTALL_STRIP_PROGRAM = @INSTALL_STRIP_PROGRAM@
+KRB5INCS = @KRB5INCS@
+KRB5LIBS = @KRB5LIBS@
 LDFLAGS = @LDFLAGS@
 LIBADD_DL = @LIBADD_DL@
 LIBOBJS = @LIBOBJS@
@@ -179,6 +181,7 @@
 ac_ct_CC = @ac_ct_CC@
 ac_ct_CXX = @ac_ct_CXX@
 ac_ct_F77 = @ac_ct_F77@
+ac_krb5_config = @ac_krb5_config@
 am__include = @am__include@
 am__leading_dot = @am__leading_dot@
 am__quote = @am__quote@
diff -u -r -N squid-3.0.STABLE16-RC1/helpers/basic_auth/SASL/Makefile.in squid-3.0.STABLE16/helpers/basic_auth/SASL/Makefile.in
--- squid-3.0.STABLE16-RC1/helpers/basic_auth/SASL/Makefile.in	2009-05-16 00:47:51.000000000 +1200
+++ squid-3.0.STABLE16/helpers/basic_auth/SASL/Makefile.in	2009-06-15 19:31:14.000000000 +1200
@@ -133,6 +133,8 @@
 INSTALL_PROGRAM = @INSTALL_PROGRAM@
 INSTALL_SCRIPT = @INSTALL_SCRIPT@
 INSTALL_STRIP_PROGRAM = @INSTALL_STRIP_PROGRAM@
+KRB5INCS = @KRB5INCS@
+KRB5LIBS = @KRB5LIBS@
 LDFLAGS = @LDFLAGS@
 LIBADD_DL = @LIBADD_DL@
 LIBOBJS = @LIBOBJS@
@@ -199,6 +201,7 @@
 ac_ct_CC = @ac_ct_CC@
 ac_ct_CXX = @ac_ct_CXX@
 ac_ct_F77 = @ac_ct_F77@
+ac_krb5_config = @ac_krb5_config@
 am__include = @am__include@
 am__leading_dot = @am__leading_dot@
 am__quote = @am__quote@
diff -u -r -N squid-3.0.STABLE16-RC1/helpers/basic_auth/SMB/Makefile.in squid-3.0.STABLE16/helpers/basic_auth/SMB/Makefile.in
--- squid-3.0.STABLE16-RC1/helpers/basic_auth/SMB/Makefile.in	2009-05-16 00:47:51.000000000 +1200
+++ squid-3.0.STABLE16/helpers/basic_auth/SMB/Makefile.in	2009-06-15 19:31:14.000000000 +1200
@@ -145,6 +145,8 @@
 INSTALL_PROGRAM = @INSTALL_PROGRAM@
 INSTALL_SCRIPT = @INSTALL_SCRIPT@
 INSTALL_STRIP_PROGRAM = @INSTALL_STRIP_PROGRAM@
+KRB5INCS = @KRB5INCS@
+KRB5LIBS = @KRB5LIBS@
 LDFLAGS = @LDFLAGS@
 LIBADD_DL = @LIBADD_DL@
 LIBOBJS = @LIBOBJS@
@@ -211,6 +213,7 @@
 ac_ct_CC = @ac_ct_CC@
 ac_ct_CXX = @ac_ct_CXX@
 ac_ct_F77 = @ac_ct_F77@
+ac_krb5_config = @ac_krb5_config@
 am__include = @am__include@
 am__leading_dot = @am__leading_dot@
 am__quote = @am__quote@
diff -u -r -N squid-3.0.STABLE16-RC1/helpers/basic_auth/squid_radius_auth/Makefile.in squid-3.0.STABLE16/helpers/basic_auth/squid_radius_auth/Makefile.in
--- squid-3.0.STABLE16-RC1/helpers/basic_auth/squid_radius_auth/Makefile.in	2009-05-16 00:47:51.000000000 +1200
+++ squid-3.0.STABLE16/helpers/basic_auth/squid_radius_auth/Makefile.in	2009-06-15 19:31:14.000000000 +1200
@@ -138,6 +138,8 @@
 INSTALL_PROGRAM = @INSTALL_PROGRAM@
 INSTALL_SCRIPT = @INSTALL_SCRIPT@
 INSTALL_STRIP_PROGRAM = @INSTALL_STRIP_PROGRAM@
+KRB5INCS = @KRB5INCS@
+KRB5LIBS = @KRB5LIBS@
 LDFLAGS = @LDFLAGS@
 LIBADD_DL = @LIBADD_DL@
 LIBOBJS = @LIBOBJS@
@@ -204,6 +206,7 @@
 ac_ct_CC = @ac_ct_CC@
 ac_ct_CXX = @ac_ct_CXX@
 ac_ct_F77 = @ac_ct_F77@
+ac_krb5_config = @ac_krb5_config@
 am__include = @am__include@
 am__leading_dot = @am__leading_dot@
 am__quote = @am__quote@
diff -u -r -N squid-3.0.STABLE16-RC1/helpers/basic_auth/squid_radius_auth/squid_rad_auth.c squid-3.0.STABLE16/helpers/basic_auth/squid_radius_auth/squid_rad_auth.c
--- squid-3.0.STABLE16-RC1/helpers/basic_auth/squid_radius_auth/squid_rad_auth.c	2009-05-16 00:47:51.000000000 +1200
+++ squid-3.0.STABLE16/helpers/basic_auth/squid_radius_auth/squid_rad_auth.c	2009-06-15 19:31:14.000000000 +1200
@@ -108,6 +108,7 @@
 #define MAXPASS		254
 #define MAXLINE         254
 
+static void md5_calc(uint8_t out[16], void *in, size_t len);
 
 static int i_send_buffer[2048];
 static int i_recv_buffer[2048];
@@ -126,7 +127,7 @@
 static u_int32_t auth_ipaddr;
 static int retries = 30;
 
-char *progname = "squid_rad_auth";
+char progname[] = "squid_rad_auth";
 int debug_flag = 0;
 
 #ifdef _SQUID_MSWIN_
diff -u -r -N squid-3.0.STABLE16-RC1/helpers/basic_auth/YP/Makefile.in squid-3.0.STABLE16/helpers/basic_auth/YP/Makefile.in
--- squid-3.0.STABLE16-RC1/helpers/basic_auth/YP/Makefile.in	2009-05-16 00:47:51.000000000 +1200
+++ squid-3.0.STABLE16/helpers/basic_auth/YP/Makefile.in	2009-06-15 19:31:14.000000000 +1200
@@ -132,6 +132,8 @@
 INSTALL_PROGRAM = @INSTALL_PROGRAM@
 INSTALL_SCRIPT = @INSTALL_SCRIPT@
 INSTALL_STRIP_PROGRAM = @INSTALL_STRIP_PROGRAM@
+KRB5INCS = @KRB5INCS@
+KRB5LIBS = @KRB5LIBS@
 LDFLAGS = @LDFLAGS@
 LIBADD_DL = @LIBADD_DL@
 LIBOBJS = @LIBOBJS@
@@ -198,6 +200,7 @@
 ac_ct_CC = @ac_ct_CC@
 ac_ct_CXX = @ac_ct_CXX@
 ac_ct_F77 = @ac_ct_F77@
+ac_krb5_config = @ac_krb5_config@
 am__include = @am__include@
 am__leading_dot = @am__leading_dot@
 am__quote = @am__quote@
diff -u -r -N squid-3.0.STABLE16-RC1/helpers/digest_auth/eDirectory/Makefile.in squid-3.0.STABLE16/helpers/digest_auth/eDirectory/Makefile.in
--- squid-3.0.STABLE16-RC1/helpers/digest_auth/eDirectory/Makefile.in	2009-05-16 00:47:52.000000000 +1200
+++ squid-3.0.STABLE16/helpers/digest_auth/eDirectory/Makefile.in	2009-06-15 19:31:14.000000000 +1200
@@ -136,6 +136,8 @@
 INSTALL_PROGRAM = @INSTALL_PROGRAM@
 INSTALL_SCRIPT = @INSTALL_SCRIPT@
 INSTALL_STRIP_PROGRAM = @INSTALL_STRIP_PROGRAM@
+KRB5INCS = @KRB5INCS@
+KRB5LIBS = @KRB5LIBS@
 LDFLAGS = @LDFLAGS@
 LIBADD_DL = @LIBADD_DL@
 LIBOBJS = @LIBOBJS@
@@ -202,6 +204,7 @@
 ac_ct_CC = @ac_ct_CC@
 ac_ct_CXX = @ac_ct_CXX@
 ac_ct_F77 = @ac_ct_F77@
+ac_krb5_config = @ac_krb5_config@
 am__include = @am__include@
 am__leading_dot = @am__leading_dot@
 am__quote = @am__quote@
diff -u -r -N squid-3.0.STABLE16-RC1/helpers/digest_auth/ldap/Makefile.in squid-3.0.STABLE16/helpers/digest_auth/ldap/Makefile.in
--- squid-3.0.STABLE16-RC1/helpers/digest_auth/ldap/Makefile.in	2009-05-16 00:47:52.000000000 +1200
+++ squid-3.0.STABLE16/helpers/digest_auth/ldap/Makefile.in	2009-06-15 19:31:14.000000000 +1200
@@ -136,6 +136,8 @@
 INSTALL_PROGRAM = @INSTALL_PROGRAM@
 INSTALL_SCRIPT = @INSTALL_SCRIPT@
 INSTALL_STRIP_PROGRAM = @INSTALL_STRIP_PROGRAM@
+KRB5INCS = @KRB5INCS@
+KRB5LIBS = @KRB5LIBS@
 LDFLAGS = @LDFLAGS@
 LIBADD_DL = @LIBADD_DL@
 LIBOBJS = @LIBOBJS@
@@ -202,6 +204,7 @@
 ac_ct_CC = @ac_ct_CC@
 ac_ct_CXX = @ac_ct_CXX@
 ac_ct_F77 = @ac_ct_F77@
+ac_krb5_config = @ac_krb5_config@
 am__include = @am__include@
 am__leading_dot = @am__leading_dot@
 am__quote = @am__quote@
diff -u -r -N squid-3.0.STABLE16-RC1/helpers/digest_auth/Makefile.in squid-3.0.STABLE16/helpers/digest_auth/Makefile.in
--- squid-3.0.STABLE16-RC1/helpers/digest_auth/Makefile.in	2009-05-16 00:47:52.000000000 +1200
+++ squid-3.0.STABLE16/helpers/digest_auth/Makefile.in	2009-06-15 19:31:14.000000000 +1200
@@ -117,6 +117,8 @@
 INSTALL_PROGRAM = @INSTALL_PROGRAM@
 INSTALL_SCRIPT = @INSTALL_SCRIPT@
 INSTALL_STRIP_PROGRAM = @INSTALL_STRIP_PROGRAM@
+KRB5INCS = @KRB5INCS@
+KRB5LIBS = @KRB5LIBS@
 LDFLAGS = @LDFLAGS@
 LIBADD_DL = @LIBADD_DL@
 LIBOBJS = @LIBOBJS@
@@ -183,6 +185,7 @@
 ac_ct_CC = @ac_ct_CC@
 ac_ct_CXX = @ac_ct_CXX@
 ac_ct_F77 = @ac_ct_F77@
+ac_krb5_config = @ac_krb5_config@
 am__include = @am__include@
 am__leading_dot = @am__leading_dot@
 am__quote = @am__quote@
diff -u -r -N squid-3.0.STABLE16-RC1/helpers/digest_auth/password/Makefile.in squid-3.0.STABLE16/helpers/digest_auth/password/Makefile.in
--- squid-3.0.STABLE16-RC1/helpers/digest_auth/password/Makefile.in	2009-05-16 00:47:52.000000000 +1200
+++ squid-3.0.STABLE16/helpers/digest_auth/password/Makefile.in	2009-06-15 19:31:14.000000000 +1200
@@ -135,6 +135,8 @@
 INSTALL_PROGRAM = @INSTALL_PROGRAM@
 INSTALL_SCRIPT = @INSTALL_SCRIPT@
 INSTALL_STRIP_PROGRAM = @INSTALL_STRIP_PROGRAM@
+KRB5INCS = @KRB5INCS@
+KRB5LIBS = @KRB5LIBS@
 LDFLAGS = @LDFLAGS@
 LIBADD_DL = @LIBADD_DL@
 LIBOBJS = @LIBOBJS@
@@ -201,6 +203,7 @@
 ac_ct_CC = @ac_ct_CC@
 ac_ct_CXX = @ac_ct_CXX@
 ac_ct_F77 = @ac_ct_F77@
+ac_krb5_config = @ac_krb5_config@
 am__include = @am__include@
 am__leading_dot = @am__leading_dot@
 am__quote = @am__quote@
diff -u -r -N squid-3.0.STABLE16-RC1/helpers/external_acl/ip_user/Makefile.in squid-3.0.STABLE16/helpers/external_acl/ip_user/Makefile.in
--- squid-3.0.STABLE16-RC1/helpers/external_acl/ip_user/Makefile.in	2009-05-16 00:47:52.000000000 +1200
+++ squid-3.0.STABLE16/helpers/external_acl/ip_user/Makefile.in	2009-06-15 19:31:15.000000000 +1200
@@ -133,6 +133,8 @@
 INSTALL_PROGRAM = @INSTALL_PROGRAM@
 INSTALL_SCRIPT = @INSTALL_SCRIPT@
 INSTALL_STRIP_PROGRAM = @INSTALL_STRIP_PROGRAM@
+KRB5INCS = @KRB5INCS@
+KRB5LIBS = @KRB5LIBS@
 LDFLAGS = @LDFLAGS@
 LIBADD_DL = @LIBADD_DL@
 LIBOBJS = @LIBOBJS@
@@ -199,6 +201,7 @@
 ac_ct_CC = @ac_ct_CC@
 ac_ct_CXX = @ac_ct_CXX@
 ac_ct_F77 = @ac_ct_F77@
+ac_krb5_config = @ac_krb5_config@
 am__include = @am__include@
 am__leading_dot = @am__leading_dot@
 am__quote = @am__quote@
diff -u -r -N squid-3.0.STABLE16-RC1/helpers/external_acl/ldap_group/Makefile.in squid-3.0.STABLE16/helpers/external_acl/ldap_group/Makefile.in
--- squid-3.0.STABLE16-RC1/helpers/external_acl/ldap_group/Makefile.in	2009-05-16 00:47:52.000000000 +1200
+++ squid-3.0.STABLE16/helpers/external_acl/ldap_group/Makefile.in	2009-06-15 19:31:15.000000000 +1200
@@ -138,6 +138,8 @@
 INSTALL_PROGRAM = @INSTALL_PROGRAM@
 INSTALL_SCRIPT = @INSTALL_SCRIPT@
 INSTALL_STRIP_PROGRAM = @INSTALL_STRIP_PROGRAM@
+KRB5INCS = @KRB5INCS@
+KRB5LIBS = @KRB5LIBS@
 LDFLAGS = @LDFLAGS@
 LIBADD_DL = @LIBADD_DL@
 LIBOBJS = @LIBOBJS@
@@ -204,6 +206,7 @@
 ac_ct_CC = @ac_ct_CC@
 ac_ct_CXX = @ac_ct_CXX@
 ac_ct_F77 = @ac_ct_F77@
+ac_krb5_config = @ac_krb5_config@
 am__include = @am__include@
 am__leading_dot = @am__leading_dot@
 am__quote = @am__quote@
diff -u -r -N squid-3.0.STABLE16-RC1/helpers/external_acl/ldap_group/squid_ldap_group.c squid-3.0.STABLE16/helpers/external_acl/ldap_group/squid_ldap_group.c
--- squid-3.0.STABLE16-RC1/helpers/external_acl/ldap_group/squid_ldap_group.c	2009-05-16 00:47:52.000000000 +1200
+++ squid-3.0.STABLE16/helpers/external_acl/ldap_group/squid_ldap_group.c	2009-06-15 19:31:15.000000000 +1200
@@ -471,9 +471,9 @@
 	}
 	rfc1738_unescape(user);
 	if (strip_nt_domain) {
-	    char *u = strchr(user, '\\');
+	    char *u = strrchr(user, '\\');
 	    if (!u)
-		u = strchr(user, '/');
+		u = strrchr(user, '/');
 	    if (u && u[1])
 		user = u + 1;
 	}
diff -u -r -N squid-3.0.STABLE16-RC1/helpers/external_acl/Makefile.in squid-3.0.STABLE16/helpers/external_acl/Makefile.in
--- squid-3.0.STABLE16-RC1/helpers/external_acl/Makefile.in	2009-05-16 00:47:52.000000000 +1200
+++ squid-3.0.STABLE16/helpers/external_acl/Makefile.in	2009-06-15 19:31:14.000000000 +1200
@@ -117,6 +117,8 @@
 INSTALL_PROGRAM = @INSTALL_PROGRAM@
 INSTALL_SCRIPT = @INSTALL_SCRIPT@
 INSTALL_STRIP_PROGRAM = @INSTALL_STRIP_PROGRAM@
+KRB5INCS = @KRB5INCS@
+KRB5LIBS = @KRB5LIBS@
 LDFLAGS = @LDFLAGS@
 LIBADD_DL = @LIBADD_DL@
 LIBOBJS = @LIBOBJS@
@@ -183,6 +185,7 @@
 ac_ct_CC = @ac_ct_CC@
 ac_ct_CXX = @ac_ct_CXX@
 ac_ct_F77 = @ac_ct_F77@
+ac_krb5_config = @ac_krb5_config@
 am__include = @am__include@
 am__leading_dot = @am__leading_dot@
 am__quote = @am__quote@
diff -u -r -N squid-3.0.STABLE16-RC1/helpers/external_acl/mswin_ad_group/Makefile.in squid-3.0.STABLE16/helpers/external_acl/mswin_ad_group/Makefile.in
--- squid-3.0.STABLE16-RC1/helpers/external_acl/mswin_ad_group/Makefile.in	2009-05-16 00:47:52.000000000 +1200
+++ squid-3.0.STABLE16/helpers/external_acl/mswin_ad_group/Makefile.in	2009-06-15 19:31:15.000000000 +1200
@@ -133,6 +133,8 @@
 INSTALL_PROGRAM = @INSTALL_PROGRAM@
 INSTALL_SCRIPT = @INSTALL_SCRIPT@
 INSTALL_STRIP_PROGRAM = @INSTALL_STRIP_PROGRAM@
+KRB5INCS = @KRB5INCS@
+KRB5LIBS = @KRB5LIBS@
 LDFLAGS = @LDFLAGS@
 LIBADD_DL = @LIBADD_DL@
 LIBOBJS = @LIBOBJS@
@@ -199,6 +201,7 @@
 ac_ct_CC = @ac_ct_CC@
 ac_ct_CXX = @ac_ct_CXX@
 ac_ct_F77 = @ac_ct_F77@
+ac_krb5_config = @ac_krb5_config@
 am__include = @am__include@
 am__leading_dot = @am__leading_dot@
 am__quote = @am__quote@
diff -u -r -N squid-3.0.STABLE16-RC1/helpers/external_acl/mswin_lm_group/Makefile.in squid-3.0.STABLE16/helpers/external_acl/mswin_lm_group/Makefile.in
--- squid-3.0.STABLE16-RC1/helpers/external_acl/mswin_lm_group/Makefile.in	2009-05-16 00:47:52.000000000 +1200
+++ squid-3.0.STABLE16/helpers/external_acl/mswin_lm_group/Makefile.in	2009-06-15 19:31:15.000000000 +1200
@@ -133,6 +133,8 @@
 INSTALL_PROGRAM = @INSTALL_PROGRAM@
 INSTALL_SCRIPT = @INSTALL_SCRIPT@
 INSTALL_STRIP_PROGRAM = @INSTALL_STRIP_PROGRAM@
+KRB5INCS = @KRB5INCS@
+KRB5LIBS = @KRB5LIBS@
 LDFLAGS = @LDFLAGS@
 LIBADD_DL = @LIBADD_DL@
 LIBOBJS = @LIBOBJS@
@@ -199,6 +201,7 @@
 ac_ct_CC = @ac_ct_CC@
 ac_ct_CXX = @ac_ct_CXX@
 ac_ct_F77 = @ac_ct_F77@
+ac_krb5_config = @ac_krb5_config@
 am__include = @am__include@
 am__leading_dot = @am__leading_dot@
 am__quote = @am__quote@
diff -u -r -N squid-3.0.STABLE16-RC1/helpers/external_acl/session/Makefile.in squid-3.0.STABLE16/helpers/external_acl/session/Makefile.in
--- squid-3.0.STABLE16-RC1/helpers/external_acl/session/Makefile.in	2009-05-16 00:47:52.000000000 +1200
+++ squid-3.0.STABLE16/helpers/external_acl/session/Makefile.in	2009-06-15 19:31:15.000000000 +1200
@@ -136,6 +136,8 @@
 INSTALL_PROGRAM = @INSTALL_PROGRAM@
 INSTALL_SCRIPT = @INSTALL_SCRIPT@
 INSTALL_STRIP_PROGRAM = @INSTALL_STRIP_PROGRAM@
+KRB5INCS = @KRB5INCS@
+KRB5LIBS = @KRB5LIBS@
 LDFLAGS = @LDFLAGS@
 LIBADD_DL = @LIBADD_DL@
 LIBOBJS = @LIBOBJS@
@@ -202,6 +204,7 @@
 ac_ct_CC = @ac_ct_CC@
 ac_ct_CXX = @ac_ct_CXX@
 ac_ct_F77 = @ac_ct_F77@
+ac_krb5_config = @ac_krb5_config@
 am__include = @am__include@
 am__leading_dot = @am__leading_dot@
 am__quote = @am__quote@
diff -u -r -N squid-3.0.STABLE16-RC1/helpers/external_acl/session/squid_session.c squid-3.0.STABLE16/helpers/external_acl/session/squid_session.c
--- squid-3.0.STABLE16-RC1/helpers/external_acl/session/squid_session.c	2009-05-16 00:47:52.000000000 +1200
+++ squid-3.0.STABLE16/helpers/external_acl/session/squid_session.c	2009-06-15 19:31:15.000000000 +1200
@@ -36,6 +36,13 @@
 #include <getopt.h>
 #endif
 
+/* At this point all Bit Types are already defined, so we must 
+   protect from multiple type definition on platform where
+   __BIT_TYPES_DEFINED__ is not defined.
+ */
+#ifndef        __BIT_TYPES_DEFINED__
+#define        __BIT_TYPES_DEFINED__
+#endif
 #if defined(HAVE_DB_185_H)
 #include <db_185.h>
 #elif defined(HAVE_DB_H)
diff -u -r -N squid-3.0.STABLE16-RC1/helpers/external_acl/unix_group/Makefile.in squid-3.0.STABLE16/helpers/external_acl/unix_group/Makefile.in
--- squid-3.0.STABLE16-RC1/helpers/external_acl/unix_group/Makefile.in	2009-05-16 00:47:52.000000000 +1200
+++ squid-3.0.STABLE16/helpers/external_acl/unix_group/Makefile.in	2009-06-15 19:31:15.000000000 +1200
@@ -135,6 +135,8 @@
 INSTALL_PROGRAM = @INSTALL_PROGRAM@
 INSTALL_SCRIPT = @INSTALL_SCRIPT@
 INSTALL_STRIP_PROGRAM = @INSTALL_STRIP_PROGRAM@
+KRB5INCS = @KRB5INCS@
+KRB5LIBS = @KRB5LIBS@
 LDFLAGS = @LDFLAGS@
 LIBADD_DL = @LIBADD_DL@
 LIBOBJS = @LIBOBJS@
@@ -201,6 +203,7 @@
 ac_ct_CC = @ac_ct_CC@
 ac_ct_CXX = @ac_ct_CXX@
 ac_ct_F77 = @ac_ct_F77@
+ac_krb5_config = @ac_krb5_config@
 am__include = @am__include@
 am__leading_dot = @am__leading_dot@
 am__quote = @am__quote@
diff -u -r -N squid-3.0.STABLE16-RC1/helpers/external_acl/wbinfo_group/Makefile.in squid-3.0.STABLE16/helpers/external_acl/wbinfo_group/Makefile.in
--- squid-3.0.STABLE16-RC1/helpers/external_acl/wbinfo_group/Makefile.in	2009-05-16 00:47:52.000000000 +1200
+++ squid-3.0.STABLE16/helpers/external_acl/wbinfo_group/Makefile.in	2009-06-15 19:31:15.000000000 +1200
@@ -113,6 +113,8 @@
 INSTALL_PROGRAM = @INSTALL_PROGRAM@
 INSTALL_SCRIPT = @INSTALL_SCRIPT@
 INSTALL_STRIP_PROGRAM = @INSTALL_STRIP_PROGRAM@
+KRB5INCS = @KRB5INCS@
+KRB5LIBS = @KRB5LIBS@
 LDFLAGS = @LDFLAGS@
 LIBADD_DL = @LIBADD_DL@
 LIBOBJS = @LIBOBJS@
@@ -179,6 +181,7 @@
 ac_ct_CC = @ac_ct_CC@
 ac_ct_CXX = @ac_ct_CXX@
 ac_ct_F77 = @ac_ct_F77@
+ac_krb5_config = @ac_krb5_config@
 am__include = @am__include@
 am__leading_dot = @am__leading_dot@
 am__quote = @am__quote@
diff -u -r -N squid-3.0.STABLE16-RC1/helpers/Makefile.in squid-3.0.STABLE16/helpers/Makefile.in
--- squid-3.0.STABLE16-RC1/helpers/Makefile.in	2009-05-16 00:47:51.000000000 +1200
+++ squid-3.0.STABLE16/helpers/Makefile.in	2009-06-15 19:31:13.000000000 +1200
@@ -113,6 +113,8 @@
 INSTALL_PROGRAM = @INSTALL_PROGRAM@
 INSTALL_SCRIPT = @INSTALL_SCRIPT@
 INSTALL_STRIP_PROGRAM = @INSTALL_STRIP_PROGRAM@
+KRB5INCS = @KRB5INCS@
+KRB5LIBS = @KRB5LIBS@
 LDFLAGS = @LDFLAGS@
 LIBADD_DL = @LIBADD_DL@
 LIBOBJS = @LIBOBJS@
@@ -179,6 +181,7 @@
 ac_ct_CC = @ac_ct_CC@
 ac_ct_CXX = @ac_ct_CXX@
 ac_ct_F77 = @ac_ct_F77@
+ac_krb5_config = @ac_krb5_config@
 am__include = @am__include@
 am__leading_dot = @am__leading_dot@
 am__quote = @am__quote@
diff -u -r -N squid-3.0.STABLE16-RC1/helpers/negotiate_auth/Makefile.in squid-3.0.STABLE16/helpers/negotiate_auth/Makefile.in
--- squid-3.0.STABLE16-RC1/helpers/negotiate_auth/Makefile.in	2009-05-16 00:47:52.000000000 +1200
+++ squid-3.0.STABLE16/helpers/negotiate_auth/Makefile.in	2009-06-15 19:31:15.000000000 +1200
@@ -117,6 +117,8 @@
 INSTALL_PROGRAM = @INSTALL_PROGRAM@
 INSTALL_SCRIPT = @INSTALL_SCRIPT@
 INSTALL_STRIP_PROGRAM = @INSTALL_STRIP_PROGRAM@
+KRB5INCS = @KRB5INCS@
+KRB5LIBS = @KRB5LIBS@
 LDFLAGS = @LDFLAGS@
 LIBADD_DL = @LIBADD_DL@
 LIBOBJS = @LIBOBJS@
@@ -183,6 +185,7 @@
 ac_ct_CC = @ac_ct_CC@
 ac_ct_CXX = @ac_ct_CXX@
 ac_ct_F77 = @ac_ct_F77@
+ac_krb5_config = @ac_krb5_config@
 am__include = @am__include@
 am__leading_dot = @am__leading_dot@
 am__quote = @am__quote@
diff -u -r -N squid-3.0.STABLE16-RC1/helpers/negotiate_auth/mswin_sspi/Makefile.in squid-3.0.STABLE16/helpers/negotiate_auth/mswin_sspi/Makefile.in
--- squid-3.0.STABLE16-RC1/helpers/negotiate_auth/mswin_sspi/Makefile.in	2009-05-16 00:47:52.000000000 +1200
+++ squid-3.0.STABLE16/helpers/negotiate_auth/mswin_sspi/Makefile.in	2009-06-15 19:31:22.000000000 +1200
@@ -132,6 +132,8 @@
 INSTALL_PROGRAM = @INSTALL_PROGRAM@
 INSTALL_SCRIPT = @INSTALL_SCRIPT@
 INSTALL_STRIP_PROGRAM = @INSTALL_STRIP_PROGRAM@
+KRB5INCS = @KRB5INCS@
+KRB5LIBS = @KRB5LIBS@
 LDFLAGS = @LDFLAGS@
 LIBADD_DL = @LIBADD_DL@
 LIBOBJS = @LIBOBJS@
@@ -198,6 +200,7 @@
 ac_ct_CC = @ac_ct_CC@
 ac_ct_CXX = @ac_ct_CXX@
 ac_ct_F77 = @ac_ct_F77@
+ac_krb5_config = @ac_krb5_config@
 am__include = @am__include@
 am__leading_dot = @am__leading_dot@
 am__quote = @am__quote@
diff -u -r -N squid-3.0.STABLE16-RC1/helpers/negotiate_auth/squid_kerb_auth/Makefile.am squid-3.0.STABLE16/helpers/negotiate_auth/squid_kerb_auth/Makefile.am
--- squid-3.0.STABLE16-RC1/helpers/negotiate_auth/squid_kerb_auth/Makefile.am	2009-05-16 00:47:52.000000000 +1200
+++ squid-3.0.STABLE16/helpers/negotiate_auth/squid_kerb_auth/Makefile.am	2009-06-15 19:31:22.000000000 +1200
@@ -10,18 +10,18 @@
 SOURCE = squid_kerb_auth.c base64.c base64.h
 EXTRA_DIST = readme.txt do.sh
 
+if HAVE_SPNEGO
+squid_kerb_auth_SOURCES = $(SOURCE)
+else
 squid_kerb_auth_SOURCES = $(SOURCE) $(SPNEGO)
+endif
 
-CPPFLAGS = $(KERBINC) -I$(srcdir)/spnegohelp -I.
+AM_CPPFLAGS = $(KERBINCS) -I$(srcdir)/spnegohelp -I.
 #-I$(top_srcdir)/include -I$(top_srcdir)/src
 LDADD = $(KERBLIBS)
 #-L$(top_builddir)/lib -lmiscutil $(XTRA_LIBS)
 
-# HEIMDAL
-#KERBINC = -DHEIMDAL -I/usr/include/heimdal
-#KERBLIBS = -lgssapi -lkrb5 -lcom_err -lasn1 -lroken
-
 # MIT
-KERBINC = 
-KERBLIBS = -lgssapi_krb5 -lkrb5 -lcom_err
+KERBINCS = @KRB5INCS@
+KERBLIBS = @KRB5LIBS@
 
diff -u -r -N squid-3.0.STABLE16-RC1/helpers/negotiate_auth/squid_kerb_auth/Makefile.in squid-3.0.STABLE16/helpers/negotiate_auth/squid_kerb_auth/Makefile.in
--- squid-3.0.STABLE16-RC1/helpers/negotiate_auth/squid_kerb_auth/Makefile.in	2009-05-16 00:47:52.000000000 +1200
+++ squid-3.0.STABLE16/helpers/negotiate_auth/squid_kerb_auth/Makefile.in	2009-06-15 19:31:22.000000000 +1200
@@ -52,10 +52,17 @@
 am__installdirs = "$(DESTDIR)$(libexecdir)"
 libexecPROGRAMS_INSTALL = $(INSTALL_PROGRAM)
 PROGRAMS = $(libexec_PROGRAMS)
+am__squid_kerb_auth_SOURCES_DIST = squid_kerb_auth.c base64.c base64.h \
+	spnegohelp/derparse.c spnegohelp/derparse.h \
+	spnegohelp/Makefile spnegohelp/spnego.c spnegohelp/spnego.h \
+	spnegohelp/spnegohelp.c spnegohelp/spnegohelp.h \
+	spnegohelp/spnegoparse.c spnegohelp/spnegoparse.h
 am__objects_1 = squid_kerb_auth.$(OBJEXT) base64.$(OBJEXT)
 am__objects_2 = derparse.$(OBJEXT) spnego.$(OBJEXT) \
 	spnegohelp.$(OBJEXT) spnegoparse.$(OBJEXT)
-am_squid_kerb_auth_OBJECTS = $(am__objects_1) $(am__objects_2)
+@HAVE_SPNEGO_FALSE@am_squid_kerb_auth_OBJECTS = $(am__objects_1) \
+@HAVE_SPNEGO_FALSE@	$(am__objects_2)
+@HAVE_SPNEGO_TRUE@am_squid_kerb_auth_OBJECTS = $(am__objects_1)
 squid_kerb_auth_OBJECTS = $(am_squid_kerb_auth_OBJECTS)
 squid_kerb_auth_LDADD = $(LDADD)
 am__DEPENDENCIES_1 =
@@ -73,7 +80,7 @@
 	--mode=link $(CCLD) $(AM_CFLAGS) $(CFLAGS) $(AM_LDFLAGS) \
 	$(LDFLAGS) -o $@
 SOURCES = $(squid_kerb_auth_SOURCES)
-DIST_SOURCES = $(squid_kerb_auth_SOURCES)
+DIST_SOURCES = $(am__squid_kerb_auth_SOURCES_DIST)
 ETAGS = etags
 CTAGS = ctags
 DISTFILES = $(DIST_COMMON) $(DIST_SOURCES) $(TEXINFOS) $(EXTRA_DIST)
@@ -99,7 +106,7 @@
 CFLAGS = @CFLAGS@
 CGIEXT = @CGIEXT@
 CPP = @CPP@
-CPPFLAGS = $(KERBINC) -I$(srcdir)/spnegohelp -I.
+CPPFLAGS = @CPPFLAGS@
 CPPUNITCONFIG = @CPPUNITCONFIG@
 CRYPTLIB = @CRYPTLIB@
 CXX = @CXX@
@@ -134,6 +141,8 @@
 INSTALL_PROGRAM = @INSTALL_PROGRAM@
 INSTALL_SCRIPT = @INSTALL_SCRIPT@
 INSTALL_STRIP_PROGRAM = @INSTALL_STRIP_PROGRAM@
+KRB5INCS = @KRB5INCS@
+KRB5LIBS = @KRB5LIBS@
 LDFLAGS = @LDFLAGS@
 LIBADD_DL = @LIBADD_DL@
 LIBOBJS = @LIBOBJS@
@@ -200,6 +209,7 @@
 ac_ct_CC = @ac_ct_CC@
 ac_ct_CXX = @ac_ct_CXX@
 ac_ct_F77 = @ac_ct_F77@
+ac_krb5_config = @ac_krb5_config@
 am__include = @am__include@
 am__leading_dot = @am__leading_dot@
 am__quote = @am__quote@
@@ -250,18 +260,16 @@
 SPNEGO = spnegohelp/derparse.c spnegohelp/derparse.h spnegohelp/Makefile spnegohelp/spnego.c spnegohelp/spnego.h spnegohelp/spnegohelp.c spnegohelp/spnegohelp.h spnegohelp/spnegoparse.c spnegohelp/spnegoparse.h
 SOURCE = squid_kerb_auth.c base64.c base64.h
 EXTRA_DIST = readme.txt do.sh
-squid_kerb_auth_SOURCES = $(SOURCE) $(SPNEGO)
+@HAVE_SPNEGO_FALSE@squid_kerb_auth_SOURCES = $(SOURCE) $(SPNEGO)
+@HAVE_SPNEGO_TRUE@squid_kerb_auth_SOURCES = $(SOURCE)
+AM_CPPFLAGS = $(KERBINCS) -I$(srcdir)/spnegohelp -I.
 #-I$(top_srcdir)/include -I$(top_srcdir)/src
 LDADD = $(KERBLIBS)
 #-L$(top_builddir)/lib -lmiscutil $(XTRA_LIBS)
 
-# HEIMDAL
-#KERBINC = -DHEIMDAL -I/usr/include/heimdal
-#KERBLIBS = -lgssapi -lkrb5 -lcom_err -lasn1 -lroken
-
 # MIT
-KERBINC = 
-KERBLIBS = -lgssapi_krb5 -lkrb5 -lcom_err
+KERBINCS = @KRB5INCS@
+KERBLIBS = @KRB5LIBS@
 all: all-am
 
 .SUFFIXES:
diff -u -r -N squid-3.0.STABLE16-RC1/helpers/negotiate_auth/squid_kerb_auth/spnegohelp/derparse.c squid-3.0.STABLE16/helpers/negotiate_auth/squid_kerb_auth/spnegohelp/derparse.c
--- squid-3.0.STABLE16-RC1/helpers/negotiate_auth/squid_kerb_auth/spnegohelp/derparse.c	2009-05-16 00:47:52.000000000 +1200
+++ squid-3.0.STABLE16/helpers/negotiate_auth/squid_kerb_auth/spnegohelp/derparse.c	2009-06-15 19:31:22.000000000 +1200
@@ -22,6 +22,7 @@
 //
 /////////////////////////////////////////////////////////////
 
+#include "config.h"
 #include <stdlib.h>
 #include <stdio.h>
 #include <memory.h>
@@ -91,7 +92,7 @@
             // Bump by 1 byte
             pbLengthData++;
 
-   #ifdef __LITTLE_ENDIAN__
+    #if defined(__LITTLE_ENDIAN__) || !defined(WORDS_BIGENDIAN)
 
             // There may be a cleaner way to do this, but for now, this seems to be
             // an easy way to do the transformation
@@ -503,7 +504,7 @@
       // Point to where we'll actually write the length
       pbData++;
 
-#ifdef __LITTLE_ENDIAN__
+#if defined(__LITTLE_ENDIAN__) || !defined(WORDS_BIGENDIAN)
 
       // There may be a cleaner way to do this, but for now, this seems to be
       // an easy way to do the transformation
diff -u -r -N squid-3.0.STABLE16-RC1/helpers/negotiate_auth/squid_kerb_auth/squid_kerb_auth.c squid-3.0.STABLE16/helpers/negotiate_auth/squid_kerb_auth/squid_kerb_auth.c
--- squid-3.0.STABLE16-RC1/helpers/negotiate_auth/squid_kerb_auth/squid_kerb_auth.c	2009-05-16 00:47:55.000000000 +1200
+++ squid-3.0.STABLE16/helpers/negotiate_auth/squid_kerb_auth/squid_kerb_auth.c	2009-06-15 19:31:22.000000000 +1200
@@ -24,6 +24,7 @@
 /*
  * Hosted at http://sourceforge.net/projects/squidkerbauth
  */
+#include "config.h"
 #include <string.h>
 #include <stdio.h>
 #include <stdlib.h>
@@ -50,16 +51,26 @@
 
 #define PROGRAM "squid_kerb_auth"
 
-#ifdef HEIMDAL
+#ifdef HAVE_HEIMDAL_KERBEROS
+#ifdef HAVE_GSSAPI_GSSAPI_H
+#include <gssapi/gssapi.h>
+#elif defined(HAVE_GSSAPI_H)
 #include <gssapi.h>
+#endif
 #define gss_nt_service_name GSS_C_NT_HOSTBASED_SERVICE
 #else
+#ifdef HAVE_GSSAPI_GSSAPI_H
 #include <gssapi/gssapi.h>
-#ifndef SOLARIS_11
+#elif defined(HAVE_GSSAPI_H)
+#include <gssapi.h>
+#endif
+#ifdef HAVE_GSSAPI_GSSAPI_KRB5_H
+#include <gssapi/gssapi_krb5.h>
+#endif
+#ifdef HAVE_GSSAPI_GSSAPI_GENERIC_H
 #include <gssapi/gssapi_generic.h>
-#else
-#define gss_nt_service_name GSS_C_NT_HOSTBASED_SERVICE
 #endif
+#define gss_nt_service_name GSS_C_NT_HOSTBASED_SERVICE
 #endif
 
 #include <krb5.h>
@@ -182,7 +193,7 @@
   char *c;
   int length=0;
   static int err=0;
-  int opt, rc, debug=0, loging=0;
+  int opt, debug=0, loging=0;
   OM_uint32 ret_flags=0, spnego_flag=0;
   char *service_name=(char *)"HTTP",*host_name=NULL;
   char *token = NULL;
@@ -197,7 +208,10 @@
   gss_buffer_desc 	input_token = GSS_C_EMPTY_BUFFER;
   gss_buffer_desc 	output_token = GSS_C_EMPTY_BUFFER;
   const unsigned char	*kerberosToken       = NULL;
+#ifndef HAVE_SPNEGO
+  int rc;
   size_t		kerberosTokenLength = 0;
+#endif
   const unsigned char	*spnegoToken         = NULL ;
   size_t		spnegoTokenLength   = 0;
 
diff -u -r -N squid-3.0.STABLE16-RC1/helpers/ntlm_auth/fakeauth/fakeauth_auth.c squid-3.0.STABLE16/helpers/ntlm_auth/fakeauth/fakeauth_auth.c
--- squid-3.0.STABLE16-RC1/helpers/ntlm_auth/fakeauth/fakeauth_auth.c	2009-05-16 00:47:55.000000000 +1200
+++ squid-3.0.STABLE16/helpers/ntlm_auth/fakeauth/fakeauth_auth.c	2009-06-15 19:31:23.000000000 +1200
@@ -159,6 +159,7 @@
 	(NEGOTIATE_UNICODE & flags ? NEGOTIATE_UNICODE : NEGOTIATE_ASCII)
 	);
     chal->hdr.type = htole32(NTLM_CHALLENGE);
+    chal->flags = flags;
     chal->unknown[6] = htole16(0x003a);
 
     d = (char *) chal + 48;
diff -u -r -N squid-3.0.STABLE16-RC1/helpers/ntlm_auth/fakeauth/Makefile.in squid-3.0.STABLE16/helpers/ntlm_auth/fakeauth/Makefile.in
--- squid-3.0.STABLE16-RC1/helpers/ntlm_auth/fakeauth/Makefile.in	2009-05-16 00:47:55.000000000 +1200
+++ squid-3.0.STABLE16/helpers/ntlm_auth/fakeauth/Makefile.in	2009-06-15 19:31:23.000000000 +1200
@@ -134,6 +134,8 @@
 INSTALL_PROGRAM = @INSTALL_PROGRAM@
 INSTALL_SCRIPT = @INSTALL_SCRIPT@
 INSTALL_STRIP_PROGRAM = @INSTALL_STRIP_PROGRAM@
+KRB5INCS = @KRB5INCS@
+KRB5LIBS = @KRB5LIBS@
 LDFLAGS = @LDFLAGS@
 LIBADD_DL = @LIBADD_DL@
 LIBOBJS = @LIBOBJS@
@@ -200,6 +202,7 @@
 ac_ct_CC = @ac_ct_CC@
 ac_ct_CXX = @ac_ct_CXX@
 ac_ct_F77 = @ac_ct_F77@
+ac_krb5_config = @ac_krb5_config@
 am__include = @am__include@
 am__leading_dot = @am__leading_dot@
 am__quote = @am__quote@
diff -u -r -N squid-3.0.STABLE16-RC1/helpers/ntlm_auth/Makefile.in squid-3.0.STABLE16/helpers/ntlm_auth/Makefile.in
--- squid-3.0.STABLE16-RC1/helpers/ntlm_auth/Makefile.in	2009-05-16 00:47:55.000000000 +1200
+++ squid-3.0.STABLE16/helpers/ntlm_auth/Makefile.in	2009-06-15 19:31:22.000000000 +1200
@@ -117,6 +117,8 @@
 INSTALL_PROGRAM = @INSTALL_PROGRAM@
 INSTALL_SCRIPT = @INSTALL_SCRIPT@
 INSTALL_STRIP_PROGRAM = @INSTALL_STRIP_PROGRAM@
+KRB5INCS = @KRB5INCS@
+KRB5LIBS = @KRB5LIBS@
 LDFLAGS = @LDFLAGS@
 LIBADD_DL = @LIBADD_DL@
 LIBOBJS = @LIBOBJS@
@@ -183,6 +185,7 @@
 ac_ct_CC = @ac_ct_CC@
 ac_ct_CXX = @ac_ct_CXX@
 ac_ct_F77 = @ac_ct_F77@
+ac_krb5_config = @ac_krb5_config@
 am__include = @am__include@
 am__leading_dot = @am__leading_dot@
 am__quote = @am__quote@
diff -u -r -N squid-3.0.STABLE16-RC1/helpers/ntlm_auth/mswin_sspi/Makefile.in squid-3.0.STABLE16/helpers/ntlm_auth/mswin_sspi/Makefile.in
--- squid-3.0.STABLE16-RC1/helpers/ntlm_auth/mswin_sspi/Makefile.in	2009-05-16 00:47:55.000000000 +1200
+++ squid-3.0.STABLE16/helpers/ntlm_auth/mswin_sspi/Makefile.in	2009-06-15 19:31:24.000000000 +1200
@@ -131,6 +131,8 @@
 INSTALL_PROGRAM = @INSTALL_PROGRAM@
 INSTALL_SCRIPT = @INSTALL_SCRIPT@
 INSTALL_STRIP_PROGRAM = @INSTALL_STRIP_PROGRAM@
+KRB5INCS = @KRB5INCS@
+KRB5LIBS = @KRB5LIBS@
 LDFLAGS = @LDFLAGS@
 LIBADD_DL = @LIBADD_DL@
 LIBOBJS = @LIBOBJS@
@@ -197,6 +199,7 @@
 ac_ct_CC = @ac_ct_CC@
 ac_ct_CXX = @ac_ct_CXX@
 ac_ct_F77 = @ac_ct_F77@
+ac_krb5_config = @ac_krb5_config@
 am__include = @am__include@
 am__leading_dot = @am__leading_dot@
 am__quote = @am__quote@
diff -u -r -N squid-3.0.STABLE16-RC1/helpers/ntlm_auth/no_check/Makefile.in squid-3.0.STABLE16/helpers/ntlm_auth/no_check/Makefile.in
--- squid-3.0.STABLE16-RC1/helpers/ntlm_auth/no_check/Makefile.in	2009-05-16 00:47:55.000000000 +1200
+++ squid-3.0.STABLE16/helpers/ntlm_auth/no_check/Makefile.in	2009-06-15 19:31:24.000000000 +1200
@@ -113,6 +113,8 @@
 INSTALL_PROGRAM = @INSTALL_PROGRAM@
 INSTALL_SCRIPT = @INSTALL_SCRIPT@
 INSTALL_STRIP_PROGRAM = @INSTALL_STRIP_PROGRAM@
+KRB5INCS = @KRB5INCS@
+KRB5LIBS = @KRB5LIBS@
 LDFLAGS = @LDFLAGS@
 LIBADD_DL = @LIBADD_DL@
 LIBOBJS = @LIBOBJS@
@@ -179,6 +181,7 @@
 ac_ct_CC = @ac_ct_CC@
 ac_ct_CXX = @ac_ct_CXX@
 ac_ct_F77 = @ac_ct_F77@
+ac_krb5_config = @ac_krb5_config@
 am__include = @am__include@
 am__leading_dot = @am__leading_dot@
 am__quote = @am__quote@
diff -u -r -N squid-3.0.STABLE16-RC1/helpers/ntlm_auth/SMB/Makefile.in squid-3.0.STABLE16/helpers/ntlm_auth/SMB/Makefile.in
--- squid-3.0.STABLE16-RC1/helpers/ntlm_auth/SMB/Makefile.in	2009-05-16 00:47:55.000000000 +1200
+++ squid-3.0.STABLE16/helpers/ntlm_auth/SMB/Makefile.in	2009-06-15 19:31:23.000000000 +1200
@@ -142,6 +142,8 @@
 INSTALL_PROGRAM = @INSTALL_PROGRAM@
 INSTALL_SCRIPT = @INSTALL_SCRIPT@
 INSTALL_STRIP_PROGRAM = @INSTALL_STRIP_PROGRAM@
+KRB5INCS = @KRB5INCS@
+KRB5LIBS = @KRB5LIBS@
 LDFLAGS = @LDFLAGS@
 LIBADD_DL = @LIBADD_DL@
 LIBOBJS = @LIBOBJS@
@@ -208,6 +210,7 @@
 ac_ct_CC = @ac_ct_CC@
 ac_ct_CXX = @ac_ct_CXX@
 ac_ct_F77 = @ac_ct_F77@
+ac_krb5_config = @ac_krb5_config@
 am__include = @am__include@
 am__leading_dot = @am__leading_dot@
 am__quote = @am__quote@
diff -u -r -N squid-3.0.STABLE16-RC1/helpers/ntlm_auth/SMB/smbval/Makefile.in squid-3.0.STABLE16/helpers/ntlm_auth/SMB/smbval/Makefile.in
--- squid-3.0.STABLE16-RC1/helpers/ntlm_auth/SMB/smbval/Makefile.in	2009-05-16 00:47:55.000000000 +1200
+++ squid-3.0.STABLE16/helpers/ntlm_auth/SMB/smbval/Makefile.in	2009-06-15 19:31:23.000000000 +1200
@@ -127,6 +127,8 @@
 INSTALL_PROGRAM = @INSTALL_PROGRAM@
 INSTALL_SCRIPT = @INSTALL_SCRIPT@
 INSTALL_STRIP_PROGRAM = @INSTALL_STRIP_PROGRAM@
+KRB5INCS = @KRB5INCS@
+KRB5LIBS = @KRB5LIBS@
 LDFLAGS = @LDFLAGS@
 LIBADD_DL = @LIBADD_DL@
 LIBOBJS = @LIBOBJS@
@@ -193,6 +195,7 @@
 ac_ct_CC = @ac_ct_CC@
 ac_ct_CXX = @ac_ct_CXX@
 ac_ct_F77 = @ac_ct_F77@
+ac_krb5_config = @ac_krb5_config@
 am__include = @am__include@
 am__leading_dot = @am__leading_dot@
 am__quote = @am__quote@
diff -u -r -N squid-3.0.STABLE16-RC1/icons/Makefile.in squid-3.0.STABLE16/icons/Makefile.in
--- squid-3.0.STABLE16-RC1/icons/Makefile.in	2009-05-16 00:47:55.000000000 +1200
+++ squid-3.0.STABLE16/icons/Makefile.in	2009-06-15 19:31:24.000000000 +1200
@@ -114,6 +114,8 @@
 INSTALL_PROGRAM = @INSTALL_PROGRAM@
 INSTALL_SCRIPT = @INSTALL_SCRIPT@
 INSTALL_STRIP_PROGRAM = @INSTALL_STRIP_PROGRAM@
+KRB5INCS = @KRB5INCS@
+KRB5LIBS = @KRB5LIBS@
 LDFLAGS = @LDFLAGS@
 LIBADD_DL = @LIBADD_DL@
 LIBOBJS = @LIBOBJS@
@@ -180,6 +182,7 @@
 ac_ct_CC = @ac_ct_CC@
 ac_ct_CXX = @ac_ct_CXX@
 ac_ct_F77 = @ac_ct_F77@
+ac_krb5_config = @ac_krb5_config@
 am__include = @am__include@
 am__leading_dot = @am__leading_dot@
 am__quote = @am__quote@
diff -u -r -N squid-3.0.STABLE16-RC1/include/autoconf.h.in squid-3.0.STABLE16/include/autoconf.h.in
--- squid-3.0.STABLE16-RC1/include/autoconf.h.in	2009-05-16 00:47:55.000000000 +1200
+++ squid-3.0.STABLE16/include/autoconf.h.in	2009-06-15 19:31:24.000000000 +1200
@@ -194,6 +194,21 @@
 /* Define to 1 if you have the <grp.h> header file. */
 #undef HAVE_GRP_H
 
+/* Define to 1 if you have the <gssapi/gssapi_generic.h> header file. */
+#undef HAVE_GSSAPI_GSSAPI_GENERIC_H
+
+/* Define to 1 if you have the <gssapi/gssapi.h> header file. */
+#undef HAVE_GSSAPI_GSSAPI_H
+
+/* Define to 1 if you have the <gssapi/gssapi_krb5.h> header file. */
+#undef HAVE_GSSAPI_GSSAPI_KRB5_H
+
+/* Define to 1 if you have the <gssapi.h> header file. */
+#undef HAVE_GSSAPI_H
+
+/* Define to 1 if you have Heimdal Kerberos */
+#undef HAVE_HEIMDAL_KERBEROS
+
 /* Define to 1 if you have the `htobe16' function. */
 #undef HAVE_HTOBE16
 
@@ -336,6 +351,9 @@
 /* Define to 1 if you have the `memset' function. */
 #undef HAVE_MEMSET
 
+/* Define to 1 if you have MIT Kerberos */
+#undef HAVE_MIT_KERBEROS
+
 /* Define to 1 if you have the `mkstemp' function. */
 #undef HAVE_MKSTEMP
 
@@ -541,6 +559,9 @@
 /* socklen_t is defined by the system headers */
 #undef HAVE_SOCKLEN_T
 
+/* Define to 1 if you have SPNEGO support */
+#undef HAVE_SPNEGO
+
 /* Define to 1 if you have the `srand48' function. */
 #undef HAVE_SRAND48
 
diff -u -r -N squid-3.0.STABLE16-RC1/include/version.h squid-3.0.STABLE16/include/version.h
--- squid-3.0.STABLE16-RC1/include/version.h	2009-05-16 00:47:59.000000000 +1200
+++ squid-3.0.STABLE16/include/version.h	2009-06-15 19:31:33.000000000 +1200
@@ -9,5 +9,5 @@
  */
 
 #ifndef SQUID_RELEASE_TIME
-#define SQUID_RELEASE_TIME 1242391665
+#define SQUID_RELEASE_TIME 1245051062
 #endif
diff -u -r -N squid-3.0.STABLE16-RC1/lib/hash.c squid-3.0.STABLE16/lib/hash.c
--- squid-3.0.STABLE16-RC1/lib/hash.c	2009-05-16 00:47:55.000000000 +1200
+++ squid-3.0.STABLE16/lib/hash.c	2009-06-15 19:31:25.000000000 +1200
@@ -312,7 +312,8 @@
 void
 hashFreeMemory(hash_table * hid)
 {
-    assert(hid != NULL);
+    if(hid == NULL)
+        return;
     if (hid->buckets)
 	xfree(hid->buckets);
     xfree(hid);
diff -u -r -N squid-3.0.STABLE16-RC1/lib/Makefile.in squid-3.0.STABLE16/lib/Makefile.in
--- squid-3.0.STABLE16-RC1/lib/Makefile.in	2009-05-16 00:47:55.000000000 +1200
+++ squid-3.0.STABLE16/lib/Makefile.in	2009-06-15 19:31:24.000000000 +1200
@@ -192,6 +192,8 @@
 INSTALL_PROGRAM = @INSTALL_PROGRAM@
 INSTALL_SCRIPT = @INSTALL_SCRIPT@
 INSTALL_STRIP_PROGRAM = @INSTALL_STRIP_PROGRAM@
+KRB5INCS = @KRB5INCS@
+KRB5LIBS = @KRB5LIBS@
 LDFLAGS = @LDFLAGS@
 LIBADD_DL = @LIBADD_DL@
 LIBOBJS = @LIBOBJS@
@@ -258,6 +260,7 @@
 ac_ct_CC = @ac_ct_CC@
 ac_ct_CXX = @ac_ct_CXX@
 ac_ct_F77 = @ac_ct_F77@
+ac_krb5_config = @ac_krb5_config@
 am__include = @am__include@
 am__leading_dot = @am__leading_dot@
 am__quote = @am__quote@
diff -u -r -N squid-3.0.STABLE16-RC1/lib/util.c squid-3.0.STABLE16/lib/util.c
--- squid-3.0.STABLE16-RC1/lib/util.c	2009-05-16 00:47:56.000000000 +1200
+++ squid-3.0.STABLE16/lib/util.c	2009-06-15 19:31:26.000000000 +1200
@@ -751,7 +751,8 @@
     /* copy string, including terminating character */
     sz = strlen(s) + 1;
 
-    p = memcpy((char *)xmalloc(sz), s, sz);
+    p = (char *)xmalloc(sz);
+    memcpy(p, s, sz);
 
     PROF_stop(xstrdup);
 
diff -u -r -N squid-3.0.STABLE16-RC1/Makefile.in squid-3.0.STABLE16/Makefile.in
--- squid-3.0.STABLE16-RC1/Makefile.in	2009-05-16 00:47:47.000000000 +1200
+++ squid-3.0.STABLE16/Makefile.in	2009-06-15 19:31:05.000000000 +1200
@@ -133,6 +133,8 @@
 INSTALL_PROGRAM = @INSTALL_PROGRAM@
 INSTALL_SCRIPT = @INSTALL_SCRIPT@
 INSTALL_STRIP_PROGRAM = @INSTALL_STRIP_PROGRAM@
+KRB5INCS = @KRB5INCS@
+KRB5LIBS = @KRB5LIBS@
 LDFLAGS = @LDFLAGS@
 LIBADD_DL = @LIBADD_DL@
 LIBOBJS = @LIBOBJS@
@@ -199,6 +201,7 @@
 ac_ct_CC = @ac_ct_CC@
 ac_ct_CXX = @ac_ct_CXX@
 ac_ct_F77 = @ac_ct_F77@
+ac_krb5_config = @ac_krb5_config@
 am__include = @am__include@
 am__leading_dot = @am__leading_dot@
 am__quote = @am__quote@
diff -u -r -N squid-3.0.STABLE16-RC1/RELEASENOTES.html squid-3.0.STABLE16/RELEASENOTES.html
--- squid-3.0.STABLE16-RC1/RELEASENOTES.html	2009-05-16 00:48:42.000000000 +1200
+++ squid-3.0.STABLE16/RELEASENOTES.html	2009-06-15 19:33:35.000000000 +1200
@@ -2,10 +2,10 @@
 <HTML>
 <HEAD>
  <META NAME="GENERATOR" CONTENT="LinuxDoc-Tools 0.9.50">
- <TITLE>Squid 3.0.STABLE16-RC1 release notes</TITLE>
+ <TITLE>Squid 3.0.STABLE16 release notes</TITLE>
 </HEAD>
 <BODY>
-<H1>Squid 3.0.STABLE16-RC1 release notes</H1>
+<H1>Squid 3.0.STABLE16 release notes</H1>
 
 <H2>Squid Developers</H2>
 <HR>
@@ -15,7 +15,7 @@
 <HR>
 <H2><A NAME="s1">1. Notice</A></H2>
 
-<P>The Squid Team are pleased to announce the release of Squid-3.0.STABLE16-RC1.</P>
+<P>The Squid Team are pleased to announce the release of Squid-3.0.STABLE16.</P>
 <P>This new release is available for download from 
 <A HREF="http://www.squid-cache.org/Versions/v3/3.0/">http://www.squid-cache.org/Versions/v3/3.0/</A> or the 
 <A HREF="http://www.squid-cache.org/Mirrors/http-mirrors.html">mirrors</A>.</P>
diff -u -r -N squid-3.0.STABLE16-RC1/scripts/Makefile.in squid-3.0.STABLE16/scripts/Makefile.in
--- squid-3.0.STABLE16-RC1/scripts/Makefile.in	2009-05-16 00:47:56.000000000 +1200
+++ squid-3.0.STABLE16/scripts/Makefile.in	2009-06-15 19:31:26.000000000 +1200
@@ -111,6 +111,8 @@
 INSTALL_PROGRAM = @INSTALL_PROGRAM@
 INSTALL_SCRIPT = @INSTALL_SCRIPT@
 INSTALL_STRIP_PROGRAM = @INSTALL_STRIP_PROGRAM@
+KRB5INCS = @KRB5INCS@
+KRB5LIBS = @KRB5LIBS@
 LDFLAGS = @LDFLAGS@
 LIBADD_DL = @LIBADD_DL@
 LIBOBJS = @LIBOBJS@
@@ -177,6 +179,7 @@
 ac_ct_CC = @ac_ct_CC@
 ac_ct_CXX = @ac_ct_CXX@
 ac_ct_F77 = @ac_ct_F77@
+ac_krb5_config = @ac_krb5_config@
 am__include = @am__include@
 am__leading_dot = @am__leading_dot@
 am__quote = @am__quote@
diff -u -r -N squid-3.0.STABLE16-RC1/snmplib/Makefile.in squid-3.0.STABLE16/snmplib/Makefile.in
--- squid-3.0.STABLE16-RC1/snmplib/Makefile.in	2009-05-16 00:47:56.000000000 +1200
+++ squid-3.0.STABLE16/snmplib/Makefile.in	2009-06-15 19:31:26.000000000 +1200
@@ -125,6 +125,8 @@
 INSTALL_PROGRAM = @INSTALL_PROGRAM@
 INSTALL_SCRIPT = @INSTALL_SCRIPT@
 INSTALL_STRIP_PROGRAM = @INSTALL_STRIP_PROGRAM@
+KRB5INCS = @KRB5INCS@
+KRB5LIBS = @KRB5LIBS@
 LDFLAGS = @LDFLAGS@
 LIBADD_DL = @LIBADD_DL@
 LIBOBJS = @LIBOBJS@
@@ -191,6 +193,7 @@
 ac_ct_CC = @ac_ct_CC@
 ac_ct_CXX = @ac_ct_CXX@
 ac_ct_F77 = @ac_ct_F77@
+ac_krb5_config = @ac_krb5_config@
 am__include = @am__include@
 am__leading_dot = @am__leading_dot@
 am__quote = @am__quote@
diff -u -r -N squid-3.0.STABLE16-RC1/src/auth/Makefile.in squid-3.0.STABLE16/src/auth/Makefile.in
--- squid-3.0.STABLE16-RC1/src/auth/Makefile.in	2009-05-16 00:47:57.000000000 +1200
+++ squid-3.0.STABLE16/src/auth/Makefile.in	2009-06-15 19:31:29.000000000 +1200
@@ -147,6 +147,8 @@
 INSTALL_PROGRAM = @INSTALL_PROGRAM@
 INSTALL_SCRIPT = @INSTALL_SCRIPT@
 INSTALL_STRIP_PROGRAM = @INSTALL_STRIP_PROGRAM@
+KRB5INCS = @KRB5INCS@
+KRB5LIBS = @KRB5LIBS@
 LDFLAGS = @LDFLAGS@
 LIBADD_DL = @LIBADD_DL@
 LIBOBJS = @LIBOBJS@
@@ -213,6 +215,7 @@
 ac_ct_CC = @ac_ct_CC@
 ac_ct_CXX = @ac_ct_CXX@
 ac_ct_F77 = @ac_ct_F77@
+ac_krb5_config = @ac_krb5_config@
 am__include = @am__include@
 am__leading_dot = @am__leading_dot@
 am__quote = @am__quote@
diff -u -r -N squid-3.0.STABLE16-RC1/src/cf.data.pre squid-3.0.STABLE16/src/cf.data.pre
--- squid-3.0.STABLE16-RC1/src/cf.data.pre	2009-05-16 00:47:57.000000000 +1200
+++ squid-3.0.STABLE16/src/cf.data.pre	2009-06-15 19:31:30.000000000 +1200
@@ -1090,7 +1090,7 @@
 	tcp_outgoing_tos ds-field [!]aclname ...
 
 	Example where normal_service_net uses the TOS value 0x00
-	and normal_service_net uses 0x20
+	and good_service_net uses 0x20
 
 	acl normal_service_net src 10.0.0.0/255.255.255.0
 	acl good_service_net src 10.0.1.0/255.255.255.0
@@ -2561,6 +2561,11 @@
 		VIOLATES the HTTP standard.  Enabling this feature
 		could make you liable for problems which it causes.
 
+		Note: override-expire does not enforce staleness - it only extends
+		freshness / min. If the server returns a Expires time which
+		is longer than your max time, Squid will still consider
+		the object fresh for that period of time.
+
 		override-lastmod enforces min age even on objects
 		that were modified recently.
 
diff -u -r -N squid-3.0.STABLE16-RC1/src/dns_internal.cc squid-3.0.STABLE16/src/dns_internal.cc
--- squid-3.0.STABLE16-RC1/src/dns_internal.cc	2009-05-16 00:47:58.000000000 +1200
+++ squid-3.0.STABLE16/src/dns_internal.cc	2009-06-15 19:31:30.000000000 +1200
@@ -58,6 +58,9 @@
 #ifndef USE_DNSSERVERS
 #ifdef _SQUID_WIN32_
 #include "squid_windows.h"
+#define REG_TCPIP_PARA_INTERFACES "SYSTEM\\CurrentControlSet\\Services\\Tcpip\\Parameters\\Interfaces"
+#define REG_TCPIP_PARA "SYSTEM\\CurrentControlSet\\Services\\Tcpip\\Parameters"
+#define REG_VXD_MSTCP "SYSTEM\\CurrentControlSet\\Services\\VxD\\MSTCP"
 #endif
 #ifndef _PATH_RESCONF
 #define _PATH_RESCONF "/etc/resolv.conf"
@@ -374,32 +377,24 @@
     char *token;
     HKEY hndKey;
 
-    if (RegOpenKey(HKEY_LOCAL_MACHINE,
-                   "SYSTEM\\CurrentControlSet\\Services\\Tcpip\\Parameters",
-                   &hndKey) == ERROR_SUCCESS) {
+    if (RegOpenKeyEx(HKEY_LOCAL_MACHINE, REG_TCPIP_PARA, 0, KEY_QUERY_VALUE, &hndKey) == ERROR_SUCCESS) {
         DWORD Type = 0;
         DWORD Size = 0;
         LONG Result;
-	Result =
-	    RegQueryValueEx(hndKey, "Domain", NULL, &Type, NULL,
-	    &Size);
+	Result = RegQueryValueEx(hndKey, "Domain", NULL, &Type, NULL, &Size);
 
 	if (Result == ERROR_SUCCESS && Size) {
 	    t = (char *) xmalloc(Size);
-	    RegQueryValueEx(hndKey, "Domain", NULL, &Type, (LPBYTE) t,
-		&Size);
+            RegQueryValueEx(hndKey, "Domain", NULL, &Type, (LPBYTE) t, &Size);
 	    debugs(78, 1, "Adding domain " << t << " from Registry");
 	    idnsAddPathComponent(t);
 	    xfree(t);
 	}
-        Result =
-            RegQueryValueEx(hndKey, "SearchList", NULL, &Type, NULL,
-                            &Size);
+	Result = RegQueryValueEx(hndKey, "SearchList", NULL, &Type, NULL, &Size);
 
         if (Result == ERROR_SUCCESS && Size) {
             t = (char *) xmalloc(Size);
-            RegQueryValueEx(hndKey, "SearchList", NULL, &Type, (LPBYTE) t,
-                            &Size);
+	    RegQueryValueEx(hndKey, "SearchList", NULL, &Type, (LPBYTE) t, &Size);
             token = strtok(t, Separator);
 
             while (token) {
@@ -431,20 +426,15 @@
     case _WIN_OS_WINNT:
         /* get nameservers from the Windows NT registry */
 
-        if (RegOpenKey(HKEY_LOCAL_MACHINE,
-                       "SYSTEM\\CurrentControlSet\\Services\\Tcpip\\Parameters",
-                       &hndKey) == ERROR_SUCCESS) {
+	if (RegOpenKeyEx(HKEY_LOCAL_MACHINE, REG_TCPIP_PARA, 0, KEY_QUERY_VALUE, &hndKey) == ERROR_SUCCESS) {
             DWORD Type = 0;
             DWORD Size = 0;
             LONG Result;
-            Result =
-                RegQueryValueEx(hndKey, "DhcpNameServer", NULL, &Type, NULL,
-                                &Size);
+	    Result = RegQueryValueEx(hndKey, "DhcpNameServer", NULL, &Type, NULL, &Size);
 
             if (Result == ERROR_SUCCESS && Size) {
                 t = (char *) xmalloc(Size);
-                RegQueryValueEx(hndKey, "DhcpNameServer", NULL, &Type, (LPBYTE) t,
-                                &Size);
+                RegQueryValueEx(hndKey, "DhcpNameServer", NULL, &Type, (LPBYTE) t, &Size);
                 token = strtok(t, ", ");
 
                 while (token) {
@@ -455,8 +445,7 @@
 		xfree(t);
             }
 
-            Result =
-                RegQueryValueEx(hndKey, "NameServer", NULL, &Type, NULL, &Size);
+            Result = RegQueryValueEx(hndKey, "NameServer", NULL, &Type, NULL, &Size);
 
             if (Result == ERROR_SUCCESS && Size) {
                 t = (char *) xmalloc(Size);
@@ -490,64 +479,62 @@
         /* get nameservers from the Windows 2000 registry */
         /* search all interfaces for DNS server addresses */
 
-        if (RegOpenKey(HKEY_LOCAL_MACHINE,
-                       "SYSTEM\\CurrentControlSet\\Services\\Tcpip\\Parameters\\Interfaces",
-                       &hndKey) == ERROR_SUCCESS) {
+	if (RegOpenKeyEx(HKEY_LOCAL_MACHINE, REG_TCPIP_PARA_INTERFACES, 0, KEY_READ, &hndKey) == ERROR_SUCCESS) {
             int i;
-            char keyname[255];
+	    DWORD MaxSubkeyLen, InterfacesCount;
+	    char *keyname;
+	    FILETIME ftLastWriteTime;
+
+	    if (RegQueryInfoKey(hndKey, NULL, NULL, NULL, &InterfacesCount, &MaxSubkeyLen, NULL, NULL, NULL, NULL, NULL, NULL) == ERROR_SUCCESS) {
+		keyname = (char *) xmalloc(++MaxSubkeyLen);
+		for (i = 0; i < (int) InterfacesCount; i++) {
+		    DWORD j;
+		    j = MaxSubkeyLen;
+		    if (RegEnumKeyEx(hndKey, i, keyname, &j, NULL, NULL, NULL, &ftLastWriteTime) == ERROR_SUCCESS) {
+			char *newkeyname;
+			newkeyname = (char *) xmalloc(sizeof(REG_TCPIP_PARA_INTERFACES) + j + 2);
+			strcpy(newkeyname, REG_TCPIP_PARA_INTERFACES);
+			strcat(newkeyname, "\\");
+			strcat(newkeyname, keyname);
+			if (RegOpenKeyEx(HKEY_LOCAL_MACHINE, newkeyname, 0, KEY_QUERY_VALUE, &hndKey2) == ERROR_SUCCESS) {
+			    DWORD Type = 0;
+			    DWORD Size = 0;
+			    LONG Result;
+			    Result = RegQueryValueEx(hndKey2, "DhcpNameServer", NULL, &Type, NULL, &Size);
+			    if (Result == ERROR_SUCCESS && Size) {
+				t = (char *) xmalloc(Size);
+				RegQueryValueEx(hndKey2, "DhcpNameServer", NULL, &Type, (LPBYTE)t, &Size);
+				token = strtok(t, ", ");
+				while (token) {
+                                    debugs(78, 1, "Adding DHCP nameserver " << token << " from Registry");
+				    idnsAddNameserver(token);
+				    token = strtok(NULL, ", ");
+				}
+				xfree(t);
+ 			    }
+
+			    Result = RegQueryValueEx(hndKey2, "NameServer", NULL, &Type, NULL, &Size);
+			    if (Result == ERROR_SUCCESS && Size) {
+				t = (char *) xmalloc(Size);
+				RegQueryValueEx(hndKey2, "NameServer", NULL, &Type, (LPBYTE)t, &Size);
+				token = strtok(t, ", ");
+				while (token) {
+				    debugs(78, 1, "Adding nameserver " << token << " from Registry");
+				    idnsAddNameserver(token);
+				    token = strtok(NULL, ", ");
+				}
 
-            for (i = 0; i < 10; i++) {
-                if (RegEnumKey(hndKey, i, (char *) &keyname,
-                               255) == ERROR_SUCCESS) {
-                    char newkeyname[255];
-                    strcpy(newkeyname,
-                           "SYSTEM\\CurrentControlSet\\Services\\Tcpip\\Parameters\\Interfaces\\");
-                    strcat(newkeyname, keyname);
-
-                    if (RegOpenKey(HKEY_LOCAL_MACHINE, newkeyname,
-                                   &hndKey2) == ERROR_SUCCESS) {
-                        DWORD Type = 0;
-                        DWORD Size = 0;
-                        LONG Result;
-                        Result =
-                            RegQueryValueEx(hndKey2, "DhcpNameServer", NULL,
-                                            &Type, NULL, &Size);
-
-                        if (Result == ERROR_SUCCESS && Size) {
-                            t = (char *) xmalloc(Size);
-                            RegQueryValueEx(hndKey2, "DhcpNameServer", NULL,
-                                            &Type, (LPBYTE) t, &Size);
-                            token = strtok(t, ", ");
-
-                            while (token) {
-                                debugs(78, 1, "Adding DHCP nameserver " << token << " from Registry");
-                                idnsAddNameserver(token);
-                                token = strtok(NULL, ", ");
+				xfree(t);
                             }
-			    xfree(t);
-                        }
 
-                        Result =
-                            RegQueryValueEx(hndKey2, "NameServer", NULL, &Type,
-                                            NULL, &Size);
-
-                        if (Result == ERROR_SUCCESS && Size) {
-                            t = (char *) xmalloc(Size);
-                            RegQueryValueEx(hndKey2, "NameServer", NULL, &Type,
-                                            (LPBYTE) t, &Size);
-                            token = strtok(t, ", ");
-
-                            while (token) {
-                                debugs(78, 1, "Adding nameserver " << token << " from Registry");
-                                idnsAddNameserver(token);
-                                token = strtok(NULL, ", ");
-                            }
-			    xfree(t);
+                            RegCloseKey(hndKey2);
                         }
 
-                        RegCloseKey(hndKey2);
+			xfree(newkeyname);
                     }
                 }
+
+		xfree(keyname);
             }
 
             RegCloseKey(hndKey);
@@ -564,14 +551,11 @@
     case _WIN_OS_WINME:
         /* get nameservers from the Windows 9X registry */
 
-        if (RegOpenKey(HKEY_LOCAL_MACHINE,
-                       "SYSTEM\\CurrentControlSet\\Services\\VxD\\MSTCP",
-                       &hndKey) == ERROR_SUCCESS) {
+	if (RegOpenKeyEx(HKEY_LOCAL_MACHINE, REG_VXD_MSTCP, 0, KEY_QUERY_VALUE, &hndKey) == ERROR_SUCCESS) {
             DWORD Type = 0;
             DWORD Size = 0;
             LONG Result;
-            Result =
-                RegQueryValueEx(hndKey, "NameServer", NULL, &Type, NULL, &Size);
+	    Result = RegQueryValueEx(hndKey, "NameServer", NULL, &Type, NULL, &Size);
 
             if (Result == ERROR_SUCCESS && Size) {
                 t = (char *) xmalloc(Size);
diff -u -r -N squid-3.0.STABLE16-RC1/src/errorpage.cc squid-3.0.STABLE16/src/errorpage.cc
--- squid-3.0.STABLE16-RC1/src/errorpage.cc	2009-05-16 00:47:58.000000000 +1200
+++ squid-3.0.STABLE16/src/errorpage.cc	2009-06-15 19:31:30.000000000 +1200
@@ -860,7 +860,7 @@
 
     if (strchr(name, ':')) {
         /* Redirection */
-        rep->setHeaders(version, HTTP_MOVED_TEMPORARILY, NULL, "text/html", 0, 0, squid_curtime);
+        rep->setHeaders(version, HTTP_MOVED_TEMPORARILY, NULL, "text/html", 0, 0, -1);
 
         if (err->request) {
             char *quoted_url = rfc1738_escape_part(urlCanonical(err->request));
@@ -870,7 +870,7 @@
         httpHeaderPutStrf(&rep->header, HDR_X_SQUID_ERROR, "%d %s", err->httpStatus, "Access Denied");
     } else {
         MemBuf *content = errorBuildContent(err);
-        rep->setHeaders(version, err->httpStatus, NULL, "text/html", content->contentSize(), 0, squid_curtime);
+        rep->setHeaders(version, err->httpStatus, NULL, "text/html", content->contentSize(), 0, -1);
         /*
          * include some information for downstream caches. Implicit
          * replaceable content. This isn't quite sufficient. xerrno is not
diff -u -r -N squid-3.0.STABLE16-RC1/src/fs/Makefile.in squid-3.0.STABLE16/src/fs/Makefile.in
--- squid-3.0.STABLE16-RC1/src/fs/Makefile.in	2009-05-16 00:47:58.000000000 +1200
+++ squid-3.0.STABLE16/src/fs/Makefile.in	2009-06-15 19:31:31.000000000 +1200
@@ -149,6 +149,8 @@
 INSTALL_PROGRAM = @INSTALL_PROGRAM@
 INSTALL_SCRIPT = @INSTALL_SCRIPT@
 INSTALL_STRIP_PROGRAM = @INSTALL_STRIP_PROGRAM@
+KRB5INCS = @KRB5INCS@
+KRB5LIBS = @KRB5LIBS@
 LDFLAGS = @LDFLAGS@
 LIBADD_DL = @LIBADD_DL@
 LIBOBJS = @LIBOBJS@
@@ -215,6 +217,7 @@
 ac_ct_CC = @ac_ct_CC@
 ac_ct_CXX = @ac_ct_CXX@
 ac_ct_F77 = @ac_ct_F77@
+ac_krb5_config = @ac_krb5_config@
 am__include = @am__include@
 am__leading_dot = @am__leading_dot@
 am__quote = @am__quote@
diff -u -r -N squid-3.0.STABLE16-RC1/src/HttpHeader.cc squid-3.0.STABLE16/src/HttpHeader.cc
--- squid-3.0.STABLE16-RC1/src/HttpHeader.cc	2009-05-16 00:47:57.000000000 +1200
+++ squid-3.0.STABLE16/src/HttpHeader.cc	2009-06-15 19:31:28.000000000 +1200
@@ -84,7 +84,7 @@
         {"Cache-Control", HDR_CACHE_CONTROL, ftPCc},
         {"Connection", HDR_CONNECTION, ftStr},
         {"Content-Base", HDR_CONTENT_BASE, ftStr},
-    {"Content-Disposition", HDR_CONTENT_DISPOSITION, ftStr},  /* for now */
+        {"Content-Disposition", HDR_CONTENT_DISPOSITION, ftStr},  /* for now */
         {"Content-Encoding", HDR_CONTENT_ENCODING, ftStr},
         {"Content-Language", HDR_CONTENT_LANGUAGE, ftStr},
         {"Content-Length", HDR_CONTENT_LENGTH, ftInt64},
@@ -124,6 +124,8 @@
         {"Title", HDR_TITLE, ftStr},
         {"Trailers", HDR_TRAILERS, ftStr},
         {"Transfer-Encoding", HDR_TRANSFER_ENCODING, ftStr},
+        {"Translate", HDR_TRANSLATE, ftStr},	/* for now. may need to crop */
+        {"Unless-Modified-Since", HDR_UNLESS_MODIFIED_SINCE, ftStr},  /* for now ignore. may need to crop */
         {"Upgrade", HDR_UPGRADE, ftStr},	/* for now */
         {"User-Agent", HDR_USER_AGENT, ftStr},
         {"Vary", HDR_VARY, ftStr},	/* for now */
diff -u -r -N squid-3.0.STABLE16-RC1/src/HttpHeader.h squid-3.0.STABLE16/src/HttpHeader.h
--- squid-3.0.STABLE16-RC1/src/HttpHeader.h	2009-05-16 00:47:57.000000000 +1200
+++ squid-3.0.STABLE16/src/HttpHeader.h	2009-06-15 19:31:28.000000000 +1200
@@ -98,6 +98,8 @@
     HDR_TITLE,
     HDR_TRAILERS,
     HDR_TRANSFER_ENCODING,
+    HDR_TRANSLATE,             /* IIS custom header we may need to cut off */
+    HDR_UNLESS_MODIFIED_SINCE,             /* IIS custom header we may need to cut off */
     HDR_UPGRADE,
     HDR_USER_AGENT,
     HDR_VARY,
diff -u -r -N squid-3.0.STABLE16-RC1/src/Makefile.in squid-3.0.STABLE16/src/Makefile.in
--- squid-3.0.STABLE16-RC1/src/Makefile.in	2009-05-16 00:47:57.000000000 +1200
+++ squid-3.0.STABLE16/src/Makefile.in	2009-06-15 19:31:28.000000000 +1200
@@ -1663,6 +1663,8 @@
 INSTALL_PROGRAM = @INSTALL_PROGRAM@
 INSTALL_SCRIPT = @INSTALL_SCRIPT@
 INSTALL_STRIP_PROGRAM = @INSTALL_STRIP_PROGRAM@
+KRB5INCS = @KRB5INCS@
+KRB5LIBS = @KRB5LIBS@
 LDFLAGS = @LDFLAGS@
 LIBADD_DL = @LIBADD_DL@
 LIBOBJS = @LIBOBJS@
@@ -1729,6 +1731,7 @@
 ac_ct_CC = @ac_ct_CC@
 ac_ct_CXX = @ac_ct_CXX@
 ac_ct_F77 = @ac_ct_F77@
+ac_krb5_config = @ac_krb5_config@
 am__include = @am__include@
 am__leading_dot = @am__leading_dot@
 am__quote = @am__quote@
diff -u -r -N squid-3.0.STABLE16-RC1/src/repl/Makefile.in squid-3.0.STABLE16/src/repl/Makefile.in
--- squid-3.0.STABLE16-RC1/src/repl/Makefile.in	2009-05-16 00:47:58.000000000 +1200
+++ squid-3.0.STABLE16/src/repl/Makefile.in	2009-06-15 19:31:32.000000000 +1200
@@ -142,6 +142,8 @@
 INSTALL_PROGRAM = @INSTALL_PROGRAM@
 INSTALL_SCRIPT = @INSTALL_SCRIPT@
 INSTALL_STRIP_PROGRAM = @INSTALL_STRIP_PROGRAM@
+KRB5INCS = @KRB5INCS@
+KRB5LIBS = @KRB5LIBS@
 LDFLAGS = @LDFLAGS@
 LIBADD_DL = @LIBADD_DL@
 LIBOBJS = @LIBOBJS@
@@ -208,6 +210,7 @@
 ac_ct_CC = @ac_ct_CC@
 ac_ct_CXX = @ac_ct_CXX@
 ac_ct_F77 = @ac_ct_F77@
+ac_krb5_config = @ac_krb5_config@
 am__include = @am__include@
 am__leading_dot = @am__leading_dot@
 am__quote = @am__quote@
diff -u -r -N squid-3.0.STABLE16-RC1/src/snmp_agent.cc squid-3.0.STABLE16/src/snmp_agent.cc
--- squid-3.0.STABLE16-RC1/src/snmp_agent.cc	2009-05-16 00:47:58.000000000 +1200
+++ squid-3.0.STABLE16/src/snmp_agent.cc	2009-06-15 19:31:32.000000000 +1200
@@ -118,13 +118,13 @@
 
         case CONF_ST_MMAXSZ:
             Answer = snmp_var_new_integer(Var->name, Var->name_length,
-                                          (snint) Config.memMaxSize >> 20,
+                                          (snint) (Config.memMaxSize >> 20),
                                           ASN_INTEGER);
             break;
 
         case CONF_ST_SWMAXSZ:
             Answer = snmp_var_new_integer(Var->name, Var->name_length,
-                                          (snint) Store::Root().maxSize() >> 10,
+                                          (snint) (Store::Root().maxSize() >> 10),
                                           ASN_INTEGER);
             break;
 
diff -u -r -N squid-3.0.STABLE16-RC1/src/squid.h squid-3.0.STABLE16/src/squid.h
--- squid-3.0.STABLE16-RC1/src/squid.h	2009-05-16 00:47:58.000000000 +1200
+++ squid-3.0.STABLE16/src/squid.h	2009-06-15 19:31:32.000000000 +1200
@@ -194,13 +194,18 @@
 
 /*
  * Filedescriptor limits in the different select loops
+ * 
+ * NP: FreeBSD 7 defines FD_SETSIZE as unsigned but Squid needs
+ *     it to be signed to compare it with signed values.
+ *     Linux and others including FreeBSD <7, define it as signed.
+ *     If this causes any issues please contact squid-dev@squid-cache.org
  */
 #if defined(USE_SELECT) || defined(USE_SELECT_WIN32)
 /* Limited by design */
-# define SQUID_MAXFD_LIMIT FD_SETSIZE
+# define SQUID_MAXFD_LIMIT    ((signed int)FD_SETSIZE)
 #elif defined(USE_POLL)
 /* Limited due to delay pools */
-# define SQUID_MAXFD_LIMIT FD_SETSIZE
+# define SQUID_MAXFD_LIMIT ((signed int)FD_SETSIZE)
 #elif defined(USE_KQUEUE) || defined(USE_EPOLL)
 # define SQUID_FDSET_NOUSE 1
 #else
diff -u -r -N squid-3.0.STABLE16-RC1/src/store_dir.cc squid-3.0.STABLE16/src/store_dir.cc
--- squid-3.0.STABLE16-RC1/src/store_dir.cc	2009-05-16 00:47:58.000000000 +1200
+++ squid-3.0.STABLE16/src/store_dir.cc	2009-06-15 19:31:32.000000000 +1200
@@ -788,9 +788,9 @@
     /* Calculate size of hash table (maximum currently 64k buckets).  */
     /* this is very bogus, its specific to the any Store maintaining an
      * in-core index, not global */
-    size_t buckets = Store::Root().maxSize() / Config.Store.avgObjectSize;
+    size_t buckets = (Store::Root().maxSize() + ( Config.memMaxSize >> 10)) / Config.Store.avgObjectSize;
     debugs(20, 1, "Swap maxSize " << Store::Root().maxSize() <<
-           " KB, estimated " << buckets << " objects");
+           " + " << ( Config.memMaxSize >> 10) << " KB, estimated " << buckets << " objects");
     buckets /= Config.Store.objectsPerBucket;
     debugs(20, 1, "Target number of buckets: " << buckets);
     /* ideally the full scan period should be configurable, for the
@@ -803,7 +803,7 @@
     store_table = hash_create(storeKeyHashCmp,
                               store_hash_buckets, storeKeyHashHash);
 
-    for (int i = 0; i < Config.cacheSwap.n_configured; i++)
+    for (int i = 0; i < Config.cacheSwap.n_configured; i++) {
         /* this starts a search of the store dirs, loading their
          * index. under the new Store api this should be
          * driven by the StoreHashIndex, not by each store.
@@ -819,7 +819,7 @@
         * Step 3: have the hash index walk the searches itself.
          */
         store(i)->init();
-
+    }
 }
 
 size_t
diff -u -r -N squid-3.0.STABLE16-RC1/src/WinSvc.cc squid-3.0.STABLE16/src/WinSvc.cc
--- squid-3.0.STABLE16-RC1/src/WinSvc.cc	2009-05-16 00:47:57.000000000 +1200
+++ squid-3.0.STABLE16/src/WinSvc.cc	2009-06-15 19:31:29.000000000 +1200
@@ -522,9 +522,7 @@
             return 1;
 
         /* Register the service Handler function */
-        svcHandle =
-            RegisterServiceCtrlHandler(WIN32_Service_name,
-                                       WIN32_svcHandler);
+        svcHandle = RegisterServiceCtrlHandler(WIN32_Service_name, WIN32_svcHandler);
 
         if (svcHandle == 0)
             return 1;
@@ -542,17 +540,15 @@
         safe_free(ConfigFile);
 
         /* get config file from Windows Registry */
-        if (RegOpenKey(HKEY_LOCAL_MACHINE, REGKEY, &hndKey) == ERROR_SUCCESS) {
+	if (RegOpenKeyEx(HKEY_LOCAL_MACHINE, REGKEY, 0, KEY_QUERY_VALUE, &hndKey) == ERROR_SUCCESS) {
             DWORD Type = 0;
             DWORD Size = 0;
             LONG Result;
-            Result =
-                RegQueryValueEx(hndKey, CONFIGFILE, NULL, &Type, NULL, &Size);
+            Result = RegQueryValueEx(hndKey, CONFIGFILE, NULL, &Type, NULL, &Size);
 
             if (Result == ERROR_SUCCESS && Size) {
                 ConfigFile = static_cast<char *>(xmalloc(Size));
-                RegQueryValueEx(hndKey, CONFIGFILE, NULL, &Type, (unsigned char *)ConfigFile,
-                                &Size);
+                RegQueryValueEx(hndKey, CONFIGFILE, NULL, &Type, (unsigned char *)ConfigFile, &Size);
             } else
                 ConfigFile = xstrdup(DefaultConfigFile);
 
@@ -560,13 +556,11 @@
 
             Type = 0;
 
-            Result =
-                RegQueryValueEx(hndKey, COMMANDLINE, NULL, &Type, NULL, &Size);
+            Result = RegQueryValueEx(hndKey, COMMANDLINE, NULL, &Type, NULL, &Size);
 
             if (Result == ERROR_SUCCESS && Size) {
                 WIN32_Service_Command_Line = static_cast<char *>(xmalloc(Size));
-                RegQueryValueEx(hndKey, COMMANDLINE, NULL, &Type, (unsigned char *)WIN32_Service_Command_Line,
-                                &Size);
+                RegQueryValueEx(hndKey, COMMANDLINE, NULL, &Type, (unsigned char *)WIN32_Service_Command_Line, &Size);
             } else
                 WIN32_Service_Command_Line = xstrdup("");
 
diff -u -r -N squid-3.0.STABLE16-RC1/test-suite/Makefile.in squid-3.0.STABLE16/test-suite/Makefile.in
--- squid-3.0.STABLE16-RC1/test-suite/Makefile.in	2009-05-16 00:47:59.000000000 +1200
+++ squid-3.0.STABLE16/test-suite/Makefile.in	2009-06-15 19:31:33.000000000 +1200
@@ -218,6 +218,8 @@
 INSTALL_PROGRAM = @INSTALL_PROGRAM@
 INSTALL_SCRIPT = @INSTALL_SCRIPT@
 INSTALL_STRIP_PROGRAM = @INSTALL_STRIP_PROGRAM@
+KRB5INCS = @KRB5INCS@
+KRB5LIBS = @KRB5LIBS@
 LDFLAGS = @LDFLAGS@
 LIBADD_DL = @LIBADD_DL@
 LIBOBJS = @LIBOBJS@
@@ -284,6 +286,7 @@
 ac_ct_CC = @ac_ct_CC@
 ac_ct_CXX = @ac_ct_CXX@
 ac_ct_F77 = @ac_ct_F77@
+ac_krb5_config = @ac_krb5_config@
 am__include = @am__include@
 am__leading_dot = @am__leading_dot@
 am__quote = @am__quote@
diff -u -r -N squid-3.0.STABLE16-RC1/tools/Makefile.in squid-3.0.STABLE16/tools/Makefile.in
--- squid-3.0.STABLE16-RC1/tools/Makefile.in	2009-05-16 00:47:59.000000000 +1200
+++ squid-3.0.STABLE16/tools/Makefile.in	2009-06-15 19:31:33.000000000 +1200
@@ -156,6 +156,8 @@
 INSTALL_PROGRAM = @INSTALL_PROGRAM@
 INSTALL_SCRIPT = @INSTALL_SCRIPT@
 INSTALL_STRIP_PROGRAM = @INSTALL_STRIP_PROGRAM@
+KRB5INCS = @KRB5INCS@
+KRB5LIBS = @KRB5LIBS@
 LDFLAGS = @LDFLAGS@
 LIBADD_DL = @LIBADD_DL@
 LIBOBJS = @LIBOBJS@
@@ -222,6 +224,7 @@
 ac_ct_CC = @ac_ct_CC@
 ac_ct_CXX = @ac_ct_CXX@
 ac_ct_F77 = @ac_ct_F77@
+ac_krb5_config = @ac_krb5_config@
 am__include = @am__include@
 am__leading_dot = @am__leading_dot@
 am__quote = @am__quote@
diff -u -r -N squid-3.0.STABLE16-RC1/tools/squidclient.cc squid-3.0.STABLE16/tools/squidclient.cc
--- squid-3.0.STABLE16-RC1/tools/squidclient.cc	2009-05-16 00:47:59.000000000 +1200
+++ squid-3.0.STABLE16/tools/squidclient.cc	2009-06-15 19:31:33.000000000 +1200
@@ -513,8 +513,8 @@
 	while ((len = myread(conn, buf, sizeof(buf))) > 0) {
 	    fsize += len;
 
-	    if (to_stdout)
-		fwrite(buf, len, 1, stdout);
+            if (to_stdout && fwrite(buf, len, 1, stdout) != 1)
+                perror("client: ERROR writing to stdout");
 	}
 
 #ifdef _SQUID_MSWIN_
